BeginPackage["QQbarThreshold`"];

USConst::usage = "For internal use only.";
Options[USConst] = {QuarkMass -> 175, alphaS -> 0.14};

Begin["`Ultrasoft`Private`"];
(***************************************************)
(* US Calculation                                  *)
(***************************************************)

(*--#[ header *)
Off[General::spell];
Off[General::spell1];
Off[SequenceLimit::seqlim];
Off[NIntegrate::slwcon];
Off[NIntegrate::ncvb];
Off[NIntegrate::ploss];
Off[NIntegrate::tmap];

$MaxExtraPrecision = 100;
(*--#] *)
(*--#[ US*General*definitions *)

CF = 4/3; CA = 3; CFmCA2 = CF - CA/2;

Log2s = {Log[nn_Integer] :> If[EvenQ[nn] && nn != 2,
      Log[2] + Log[nn/2], Log[nn]]};

ComplexSimplify = {Im[L[X_]] -> 0, Re[L[X_]] -> L[X], Im[L[X_]^2] -> 0,
    Re[L[X_]^2] -> L[X]^2, Im[1/ep] -> 0, Re[1/ep] -> 1/ep, Im[1/ep^2] -> 0,
    Re[1/ep^2] -> 1/ep^2, Im[(x_) + (y_)] -> Im[x] + Im[y],
    Im[(x_)*(y_)] -> Re[x]*Im[y] + Im[x]*Re[y], Re[(x_) + (y_)] ->
     Re[x] + Re[y], Re[(x_)*(y_)] -> Re[x]*Re[y] - Im[x]*Im[y]};
(*--#] *)
(*--#[ General*definitions*for*type*I *)

IItypeI[a_, n_, v_] := (n + 3)*(n + 2)*((n + 1)/6)*Gamma[a + 1]*
    (2/(1 + v))^(1 + a)*Hypergeometric2F1[-n, 1 + a, 4, 2/(1 + v)];
dIItypeI[a_, n_, v_] := D[IItypeI[aa, n, v], aa] /. aa -> a;
JJtypeI[a_, n_, v_] := Sum[((-1)^mm/mm!)*Binomial[n + 3, n - mm]*
     (2/(1 + v))^(1 + a + mm)*(Gamma[1 + a + mm]/(1 + a + mm))*
     Hypergeometric2F1[1, 1 + a + mm, 2 + a + mm, (1 - v)/(1 + v)],
    {mm, 0, n}];
KKtypeI[a_, n_, s_, v_] := Sum[((-1)^t/t!)*Binomial[s + 1, s - t]*v^t*
     IItypeI[a + t, n, v], {t, 0, s}];
HH0[n_, EE_, v_] := 2*(Sqrt[-EE]/v)*(((v^2 - 1)/4)*IItypeI[3, n, v] +
     (n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))*IItypeI[2, n, v]);
HH1[n_, EE_, v_] := (CF/v)*(((v^2 - 1)/4)*(JJtypeI[3, n, v] +
       (EulerGamma + Log[v])*IItypeI[3, n, v] + dIItypeI[3, n, v]) +
     (n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))*(JJtypeI[2, n, v] +
       (EulerGamma + Log[v])*IItypeI[2, n, v] + dIItypeI[2, n, v]));
HH1AS[n_, EE_, v_] := Normal[Series[HH1[n, EE, vp], {vp, 1, 1}]] /. vp -> v;
HH2[n_, EE_, v_, smax_] := (CF^2/(2*Sqrt[-EE]))*
   Sum[(1/((s + 1)^2*(s + 1 - CF/(2*Sqrt[-EE]))))*
     (((v^2 - 1)/4)*KKtypeI[4, n, s, v] + (n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))*
       KKtypeI[3, n, s, v]), {s, 0, smax}]


Int00g2[EE_, n_, k_] := Im[k*(Sqrt[1/(k - EE)]/2)^5*
    (1/((n + 1)*(n + 2)^3*(n + 3)*(n + 2 - CFmCA2*(Sqrt[1/(k - EE)]/2))))*
    HH0[n, EE, Sqrt[-EE/(k - EE)]]^2]
dG00g2single[EE_, n_] :=
  CFmCA2^2*Re[NIntegrate[Im[k*(v/(2*Sqrt[-EE]))^5*
        (1/((n + 1)*(n + 2)^3*(n + 3)*(n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))))*
        HH0[n, EE, v]^2 /. v -> Sqrt[-EE/(k - EE)]],
     {k, 0, 10, 50, 10^3, 10^6, 10^9, 10^12, 10^21}]]
dG00g2[EE_, nmax_] := Sum[dG00g2single[EE, n], {n, 0, nmax}]
Int01g2[EE_, n_, k_] :=
  Im[k*(v/(2*Sqrt[-EE]))^5*(1/((n + 1)*(n + 2)^3*(n + 3)*
       (n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))))*HH0[n, EE, v]*HH1[n, EE, v] /.
    v -> Sqrt[-EE/(k - EE)]]
Int01g2AS[EE_, n_, k_] :=
  Im[k*(v/(2*Sqrt[-EE]))^5*(1/((n + 1)*(n + 2)^3*(n + 3)*
       (n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))))*HH0[n, EE, v]*
     If[k < 2/10, HH1AS[n, EE, v], HH1[n, EE, v]] /. v -> Sqrt[-EE/(k - EE)]]
dG01g2single[EE_, n_, kmin_] :=
  CFmCA2^2*Re[NIntegrate[Int01g2[EE, n, k], {k, kmin, 10^(-1), 1, 50, 10^3,
      10^6, 10^9, 10^12}]]
dG01g2singleAS[EE_, n_] := CFmCA2^2*Re[NIntegrate[Int01g2AS[EE, n, k],
     {k, 0, 2/10, 1, 50, 10^3, 10^6, 10^9, 10^12}]]
dG01g2[EE_, nmax_, kmin_] := Sum[dG01g2single[EE, n, kmin], {n, 0, nmax}]
dG01g2AS[EE_, nmax_] := Sum[dG01g2singleAS[EE, n], {n, 0, nmax}]
Int11g2AS[EE_, n_, k_] :=
  Im[k*(v/(2*Sqrt[-EE]))^5*(1/((n + 1)*(n + 2)^3*(n + 3)*
       (n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))))*If[k < 10^(-1),
      HH1AS[n, EE, v]^2, HH1[n, EE, v]^2] /. v -> Sqrt[-EE/(k - EE)]]
Int11g2ASv[EE_, n_, v_] := Im[(1/(16*Sqrt[-EE]))*(1 - v^2)*
    (1/((n + 1)*(n + 2)^3*(n + 3)*(n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))))*
    If[v > 0.99, HH1AS[n, EE, v]^2, HH1[n, EE, v]^2]]
dG11g2singleAS[EE_, n_] := CFmCA2^2*Re[NIntegrate[Int11g2AS[EE, n, k],
     {k, 0, 10^(-1), 1, 50, 10^3, 10^6, 10^9, 10^12}]]
dG11g2singleASv[EE_, n_] :=
  CFmCA2^2*Re[NIntegrate[Int11g2ASv[EE, n, v], {v, 0, 0.01, 0.99, 1}]]
dG11g2AS[EE_, nmax_] := Sum[dG11g2singleAS[EE, n], {n, 0, nmax}]
dG11g2ASv[EE_, nmax_] := Sum[dG11g2singleASv[EE, n], {n, 0, nmax}]
Int02g2[EE_, n_, v_, smax_] := Im[(1/(16*Sqrt[-EE]))*(1 - v^2)*
    (1/((n + 1)*(n + 2)^3*(n + 3)*(n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))))*
    HH0[n, EE, v]*HH2[n, EE, v, smax]]
dG02g2single[EE_, n_, smax_] :=
  CFmCA2^2*Re[NIntegrate[Int02g2[EE, n, v, smax], {v, 0, 0.01, 0.99, 1}]]
dG02g2[EE_, nmax_, smax_] := Sum[dG02g2singleAS[EE, n, smax], {n, 0, nmax}]
Int12g2[EE_, n_, v_, smax_] := Im[(1/(16*Sqrt[-EE]))*(1 - v^2)*
    (1/((n + 1)*(n + 2)^3*(n + 3)*(n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))))*
    If[v > 0.99, HH1AS[n, EE, v], HH1[n, EE, v]]*HH2[n, EE, v, smax]]
dG12g2single[EE_, n_, smax_] :=
  CFmCA2^2*Re[NIntegrate[Int12g2[EE, n, v, smax], {v, 0, 0.01, 0.99, 1}]]
dG12g2[EE_, nmax_, smax_] := Sum[dG12g2singleAS[EE, n, smax], {n, 0, nmax}]
Int22g2[EE_, n_, v_, smax_] := Im[(1/(16*Sqrt[-EE]))*(1 - v^2)*
    (1/((n + 1)*(n + 2)^3*(n + 3)*(n + 2 - CFmCA2*(v/(2*Sqrt[-EE])))))*
    HH2[n, EE, v, smax]^2]
dG22g2single[EE_, n_, smax_] :=
  CFmCA2^2*Re[NIntegrate[Int22g2[EE, n, v, smax], {v, 0, 0.01, 0.99, 1}]]
dG22g2[EE_, nmax_, smax_] := Sum[dG22g2single[EE, n, smax], {n, 0, nmax}];

kktypeI[npole_, n_, s_, v_] := ((v^2 - 1)/4)*KKtypeI[4, n, s, v] +
    (n + 2 - (CFmCA2/CF)*npole*v)*KKtypeI[3, n, s, v];
Intdpg2[npole_, n_, v_] := (1 - v^2)*(1/((n + 1)*(n + 2)^3*(n + 3)*
      (n + 2 - (CFmCA2/CF)*npole*v)))*kktypeI[npole, n, npole - 1, v]^2;

Intspg2term1alt[npole_, n_, v_] :=
   (1 - v^2)*(1/((n + 1)*(n + 2)^3*(n + 3)*(n + 2 - (CFmCA2/CF)*npole*v)))*
    ((1/npole)*(1 - (CFmCA2/CF)*npole*(v/(n + 2 - (CFmCA2/CF)*npole*v)))*
      kktypeI[npole, n, npole - 1, v]^2 + 2*kktypeI[npole, n, npole - 1, v]*
      (CFmCA2/CF)*v*KKtypeI[3, n, npole - 1, v]);
Intspg2term2alt[npole_, n_, v_, smax_] :=
   (1 - v^2)*(1/((n + 1)*(n + 2)^3*(n + 3)*(n + 2 - (CFmCA2/CF)*npole*v)))*2*
    kktypeI[npole, n, npole - 1, v]*
    (Sum[(1/(s + 1 - npole))*kktypeI[npole, n, s, v], {s, 0, npole - 2}] +
     Sum[(1/(s + 1 - npole))*kktypeI[npole, n, s, v], {s, npole, smax}]);
(*--#] *)
(*--#[ General*definitions*for*type*II *)

ImGhat[e_] := CF*Im[-Sqrt[-e]/CF - Log[2*Sqrt[-e]] -
      PolyGamma[0, 1 - CF/(2*Sqrt[-e])]];
ReGhat[e_] := CF*Re[-Sqrt[-e]/CF - Log[2*Sqrt[-e]] + 1/2 - EulerGamma -
      PolyGamma[0, 1 - CF/(2*Sqrt[-e])]];

s1[x_, LL_, all] := x + (LL/(1 - LL))*Hypergeometric2F1[1 - LL, 1, 2 - LL,
      1 - 1/x];
s1[x_, LL_, g0] := s1[x, LL, all] - x;
s1[x_, LL_, g1] := s1[x, LL, all] - x + LL*x*(Log[x]/(1 - x));
s2[x_, LL_, all] := (-(1 - 1/x))*(Hypergeometric2F1[1 - LL, 1, 2 - LL,
       1 - 1/x]/(1 - LL)) - PolyGamma[0, 1 - LL];
s2[x_, LL_, g0] := s2[x, LL, all] - (EulerGamma - Log[x]);
s2[x_, LL_, g1] := s2[x, LL, g0] - LL*(Zeta[2] - PolyLog[2, 1 - 1/x]);

s1pole[x_, n_] := (1/epl)*n*(1 - 1/x)^(n - 1) +
   Sum[(s/(s - n))*(1 - 1/x)^(s - 1), {s, 1, n - 1}] + x*(1 - 1/x)^n +
   n*(1 - 1/x)^(n - 1)*Log[x]
s2pole[x_, n_] := (1/epl)*(1 - (1 - 1/x)^n) +
   Sum[(1/(s - n))*(1 - (1 - 1/x)^s), {s, 1, n - 1}] + EulerGamma -
   (1 - 1/x)^n*Log[x]
s1pole[x_, n_, all] := s1pole[x, n];
s1pole[x_, n_, g0] := s1pole[x, n, all] - x;
s1pole[x_, n_, g1] := s1pole[x, n, all] - x + n*x*(Log[x]/(1 - x));
s2pole[x_, n_, all] := s2pole[x, n];
s2pole[x_, n_, g0] := s2pole[x, n, all] - (EulerGamma - Log[x]);
s2pole[x_, n_, g1] := s2pole[x, n, g0] - n*(Zeta[2] - PolyLog[2, 1 - 1/x]);

AV[p_, e_, sub_] := (1/Sqrt[-e])*(1/(2*I))*
     ((1/xp^2)*s1[xp, CF/(2*Sqrt[-e]), sub] -
      (1/xm^2)*s1[xm, CF/(2*Sqrt[-e]), sub]) /.
    {xp -> 1/2 - I*(p/(2*Sqrt[-e])), xm -> 1/2 + I*(p/(2*Sqrt[-e]))};
AVy[p_, y_, sub_] := (1/y)*(1/(2*I))*((1/xp^2)*s1[xp, CF/(2*y), sub] -
      (1/xm^2)*s1[xm, CF/(2*y), sub]) /. {xp -> 1/2 - I*(p/(2*y)),
     xm -> 1/2 + I*(p/(2*y))};
ANA[p_, e_, sub_] :=
   (CA/2)*((1/(2*I))*(1/p^2)*(s2[xp, CF/(2*Sqrt[-e]), sub] -
        s2[xm, CF/(2*Sqrt[-e]), sub]) - (1/2)*(1/(2*Sqrt[-e]*p))*
       ((1/xp^2)*s1[xp, CF/(2*Sqrt[-e]), sub] +
        (1/xm^2)*s1[xm, CF/(2*Sqrt[-e]), sub])) /.
    {xp -> 1/2 - I*(p/(2*Sqrt[-e])), xm -> 1/2 + I*(p/(2*Sqrt[-e]))};
ANAy[p_, y_, sub_] :=
   (CA/2)*((1/(2*I))*(1/p^2)*(s2[xp, CF/(2*y), sub] - s2[xm, CF/(2*y),
         sub]) - (1/2)*(1/(2*y*p))*((1/xp^2)*s1[xp, CF/(2*y), sub] +
        (1/xm^2)*s1[xm, CF/(2*y), sub])) /. {xp -> 1/2 - I*(p/(2*y)),
     xm -> 1/2 + I*(p/(2*y))};
AV0y[p_, y_] := 2*(p/(p^2 + y^2));
AV1[p_, e_] := 2*CF*(ArcTan[p/Sqrt[-e]]/(p^2 - e));
AV1y[p_, y_] := 2*CF*(ArcTan[p/y]/(p^2 + y^2));
SubAV1[p_, y_] := (-(p^2 + y^2)^(-1))*((2*CF)/p)*(-CF)*
    (y/CF + Log[2*y] - 1/2 + EulerGamma + PolyGamma[0, 1 - CF/(2*y)]);
SubAV11[p_, y_] := (-(p^2 + y^2)^(-1))*((2*CF)/p)*(-CF)*
    (Log[2*y] - 1/2 + EulerGamma + PolyGamma[0, 1 - CF/(2*y)]);
SubAV10[p_, y_] := -2*(1/(p^2 + y^2))*((2*CF)/p)*(-y)
ANA0y[p_, y_] := (CA/2)*(1/p)*((1/p)*ArcTan[p/y] - y/(p^2 + y^2));
SubANA0y[p_, y_] := (CA/2)*(-2/p^3)*(-y)
ANA0subEx[p_, y_] := ANA0y[p, y] + SubANA0y[p, y]
ANA0subLarge[p_, y_] := (3*Pi)/(4*p^2) + (2*y^3)/p^5 - (9*y^5)/(5*p^7) +
    (12*y^7)/(7*p^9);
ANA0sub[p_, y_] := If[Re[p] < 10^4, ANA0subEx[p, y], ANA0subLarge[p, y]];
SubANA1y[p_, y_] := (CA/2)*(-2/p^3)*(-CF)*(Log[2*y] - 1/2 + EulerGamma +
     PolyGamma[0, 1 - CF/(2*y)]);

AA[p_, e_, sub_] := (1/(2*I))*(s2[xp, CF/(2*Sqrt[-e]), sub] -
      s2[xm, CF/(2*Sqrt[-e]), sub]) /. {xp -> 1/2 - I*(p/(2*Sqrt[-e])),
     xm -> 1/2 + I*(p/(2*Sqrt[-e]))};
AAy[p_, y_] := (1/(2*I))*(s2[xp, CF/(2*y), all] - s2[xm, CF/(2*y), all]) /.
    {xp -> 1/2 - I*(p/(2*y)), xm -> 1/2 + I*(p/(2*y))};
SubAA[p_, y_] := (-p^(-1))*(-CF)*(y/CF + Log[2*y] - 1/2 + EulerGamma +
     PolyGamma[0, 1 - CF/(2*y)]);
AAVNA0[p_, y_] := (1/(2*I))*(s2[xp, CF/(2*y), all] -
      s2[xm, CF/(2*y), all]) /. {xp -> 1/2 - I*(p/(2*y)),
     xm -> 1/2 + I*(p/(2*y))};
SubVNA0[y_] := (-CF)*(1/(2*LL) + Log[2*y] - 1/2 + EulerGamma +
      PolyGamma[0, 1 - LL]) /. LL -> CF/(2*y);

ANAsubex[p_, e_] := ANA[p, e, g0] + (CA/2)*(2/p^3)*CF*
     (Log[2*Sqrt[-e]] - 1/2 + EulerGamma + PolyGamma[0,
       1 - CF/(2*Sqrt[-e])] - Log[p]);
AAsubex[p_, e_] := AA[p, e, g0] + (1/p)*CF*(Log[2*Sqrt[-e]] - 1/2 +
      EulerGamma + PolyGamma[0, 1 - CF/(2*Sqrt[-e])]);
ANAsubasymptotic[p_, e_] := (-(3/2))*CA*LL^2*Pi*q^4*y^2 +
     (5/6)*CA*LL^2*(2 + LL^2)*Pi*q^6*y^4 - (7/90)*CA*LL^2*
      (23 + 20*LL^2 + 2*LL^4)*Pi*q^8*y^6 + (1/70)*CA*LL^2*
      (132 + 154*LL^2 + 28*LL^4 + LL^6)*Pi*q^10*y^8 +
     (1/3)*CA*LL*q^5*y^3*(-12 + 4*EulerGamma - 9*LL + 8*EulerGamma*LL^2 +
       (4 + 8*LL^2)*Log[q] + 4*Log[2*y] + 8*LL^2*Log[2*y] +
       (4 + 8*LL^2)*PolyGamma[0, 1 - LL]) - (1/30)*CA*LL*q^7*y^5*
      (-235 + 36*EulerGamma - 470*LL + 40*LL^2 + 120*EulerGamma*LL^2 +
       50*LL^3 + 24*EulerGamma*LL^4 + 12*(3 + 10*LL^2 + 2*LL^4)*Log[q] +
       36*Log[2*y] + 120*LL^2*Log[2*y] + 24*LL^4*Log[2*y] +
       12*(3 + 10*LL^2 + 2*LL^4)*PolyGamma[0, 1 - LL]) +
     (1/315)*CA*LL*q^9*y^7*(-3696 + 360*EulerGamma - 11564*LL + 840*LL^2 +
       1568*EulerGamma*LL^2 + 1155*LL^3 + 126*LL^4 + 560*EulerGamma*LL^4 +
       98*LL^5 + 32*EulerGamma*LL^6 + 8*(45 + 196*LL^2 + 70*LL^4 + 4*LL^6)*
        Log[q] + 360*Log[2*y] + 1568*LL^2*Log[2*y] + 560*LL^4*Log[2*y] +
       32*LL^6*Log[2*y] + 8*(45 + 196*LL^2 + 70*LL^4 + 4*LL^6)*
        PolyGamma[0, 1 - LL]) /. {q -> 1/p, y -> Sqrt[-e],
     LL -> CF/(2*Sqrt[-e])};
ANAsubasymptotic2[p_, e_] := (-(3/2))*CA*LL^2*Pi*q^4*y^2 +
     (5/6)*CA*LL^2*(2 + LL^2)*Pi*q^6*y^4 - (7/90)*CA*LL^2*
      (23 + 20*LL^2 + 2*LL^4)*Pi*q^8*y^6 + (1/70)*CA*LL^2*
      (132 + 154*LL^2 + 28*LL^4 + LL^6)*Pi*q^10*y^8 +
     (1/9)*CA*LL*q^5*y^3*(5 + 12*EulerGamma + 12*LL - 38*LL^2 +
       24*EulerGamma*LL^2 + 12*(1 + 2*LL^2)*Log[q] + 12*Log[2*y] +
       24*LL^2*Log[2*y] + 12*(1 + 2*LL^2)*PolyGamma[0, 1 - LL]) -
     (1/150)*CA*LL*q^7*y^5*(129 + 180*EulerGamma + 300*LL - 790*LL^2 +
       600*EulerGamma*LL^2 + 60*LL^3 - 254*LL^4 + 120*EulerGamma*LL^4 +
       60*(3 + 10*LL^2 + 2*LL^4)*Log[q] + 180*Log[2*y] + 600*LL^2*Log[2*y] +
       120*LL^4*Log[2*y] + 60*(3 + 10*LL^2 + 2*LL^4)*PolyGamma[0, 1 - LL]) +
     (1/11025)*(CA*LL*q^9*y^7*(11325 + 12600*EulerGamma + 27440*LL -
        64036*LL^2 + 54880*EulerGamma*LL^2 + 9800*LL^3 - 38290*LL^4 +
        19600*EulerGamma*LL^4 + 560*LL^5 - 2764*LL^6 + 1120*EulerGamma*LL^6 + \
        280*(45 + 196*LL^2 + 70*LL^4 + 4*LL^6)*Log[q] + 12600*Log[2*y] +
        54880*LL^2*Log[2*y] + 19600*LL^4*Log[2*y] + 1120*LL^6*Log[2*y] +
        280*(45 + 196*LL^2 + 70*LL^4 + 4*LL^6)*PolyGamma[0, 1 - LL])) /.
    {q -> 1/p, y -> Sqrt[-e], LL -> CF/(2*Sqrt[-e])};
AAsubasymptotic[p_, e_] := (-(1/4))*CF^2*Pi*q^2 + (CF^4*(2 + LL^2)*Pi*q^4)/
      (48*LL^2) - (CF^6*(23 + 20*LL^2 + 2*LL^4)*Pi*q^6)/(2880*LL^4) +
     (CF^8*(132 + 154*LL^2 + 28*LL^4 + LL^6)*Pi*q^8)/(80640*LL^6) +
     (1/2)*q*(CF - 2*CF*Log[q]) + (1/(24*LL^2))*
      (CF^3*q^3*(-27 + 2*EulerGamma + 6*LL + 4*EulerGamma*LL^2 +
        (2 + 4*LL^2)*Log[CF/LL] + 2*Log[q] + 4*LL^2*Log[q] +
        (2 + 4*LL^2)*PolyGamma[0, 1 - LL])) - (1/(960*LL^4))*
      (CF^5*q^5*(-515 + 12*EulerGamma + 60*LL + 20*LL^2 +
        40*EulerGamma*LL^2 + 20*LL^3 + 8*EulerGamma*LL^4 +
        4*(3 + 10*LL^2 + 2*LL^4)*Log[CF/LL] + 12*Log[q] + 40*LL^2*Log[q] +
        8*LL^4*Log[q] + 4*(3 + 10*LL^2 + 2*LL^4)*PolyGamma[0, 1 - LL])) +
     (1/(80640*LL^6))*(CF^7*q^7*(-15939 + 180*EulerGamma + 1176*LL +
        630*LL^2 + 784*EulerGamma*LL^2 + 700*LL^3 + 84*LL^4 +
        280*EulerGamma*LL^4 + 56*LL^5 + 16*EulerGamma*LL^6 +
        4*(45 + 196*LL^2 + 70*LL^4 + 4*LL^6)*Log[CF/LL] + 180*Log[q] +
        784*LL^2*Log[q] + 280*LL^4*Log[q] + 16*LL^6*Log[q] +
        4*(45 + 196*LL^2 + 70*LL^4 + 4*LL^6)*PolyGamma[0, 1 - LL])) -
     (1/(5806080*LL^8))*(CF^9*q^9*(-378711 + 2520*EulerGamma + 19632*LL +
        13356*LL^2 + 13088*EulerGamma*LL^2 + 15960*LL^3 + 3276*LL^4 +
        6384*EulerGamma*LL^4 + 2352*LL^5 + 144*LL^6 + 672*EulerGamma*LL^6 +
        72*LL^7 + 16*EulerGamma*LL^8 + 8*(315 + 1636*LL^2 + 798*LL^4 +
          84*LL^6 + 2*LL^8)*Log[CF/LL] + 2520*Log[q] + 13088*LL^2*Log[q] +
        6384*LL^4*Log[q] + 672*LL^6*Log[q] + 16*LL^8*Log[q] +
        8*(315 + 1636*LL^2 + 798*LL^4 + 84*LL^6 + 2*LL^8)*
         PolyGamma[0, 1 - LL])) /. {q -> 1/p, y -> Sqrt[-e],
     LL -> CF/(2*Sqrt[-e])};
ANAsub[p_, e_] := If[Re[p] < 10^4, ANAsubex[p, e], ANAsubasymptotic[p, e]];
ANAsub2[p_, e_] := If[Re[p] < 10^4, ANAsubex[p, e], ANAsubasymptotic2[p, e]];

AAsub[p_, e_] := If[Re[p] < 10^4, AAsubex[p, e], AAsubasymptotic[p, e]];

xnp = 1/2 - I*(p/(CF/n));
xnm = 1/2 + I*(p/(CF/n));
znp = 1 - 1/xnp;
znm = 1 - 1/xnm;
ResidAV[pp_, nn_] := (1/(I*(CF/n)))*(n*(znp^(n - 1)/xnp^2) -
      n*(znm^(n - 1)/xnm^2)) /. {p -> pp, n -> nn};
ResidAVsub[pp_, nn_] :=
  (1/(I*(CF/n)))*(n*(znp^(n - 1)/xnp^2) - n*(znm^(n - 1)/xnm^2)) -
    (1/(pp^2 + CF^2/(4*nn^2)))*2*(CF/pp)*CF /. {p -> pp, n -> nn}
ResidAAsub[pp_, nn_] := (1/(2*I))*(znm^nn - znp^nn) - CF/pp /.
    {n -> nn, p -> pp};
ResidVNA1[pp_, nn_] := (1/(I*(CF/n)))*(n*(znp^(n - 1)/xnp^2) -
     n*(znm^(n - 1)/xnm^2)) /. {p -> pp, n -> nn}
ResidVNA2[pp_, nn_] := (CA/2)*((1/(2*I*p^2))*(1 - znp^n - (1 - znm^n)) -
     (1/(2*(CF/n)*p))*(n*(znp^(n - 1)/xnp^2) + n*(znm^(n - 1)/xnm^2)) -
     2*(CF/pp^3)) /. {p -> pp, n -> nn}
AVpole[p_, n_, sub_] := Simplify[
    Series[(1/yh)*(1/(2*I))*((1/xp^2)*s1pole[xp, n, sub] -
         (1/xm^2)*s1pole[xm, n, sub]) /. {xp -> 1/2 - I*(p/(2*yh)),
        xm -> 1/2 + I*(p/(2*yh))} /. yh -> CF/(2*(n - epl)), {epl, 0, 0}]];
ANApole[p_, n_, sub_] :=
   (CA/2)*Simplify[Series[
      (1/(2*I))*(1/p^2)*(s2pole[xp, n, sub] - s2pole[xm, n, sub]) -
         (1/2)*(1/(2*yh*p))*((1/xp^2)*s1pole[xp, n, sub] +
           (1/xm^2)*s1pole[xm, n, sub]) /. {xp -> 1/2 - I*(p/(2*yh)),
         xm -> 1/2 + I*(p/(2*yh))} /. yh -> CF/(2*(n - epl)), {epl, 0, 0}]];

E01[p_, e_] := (-Pi^(-1))*(p^2 - e);
E0log[p_, e_] := E01[p, e]*-2*Log[p^2 - e];
E11[p_, pp_, e_] := ((CF - CA/2)/Pi^2)*
    (((p^2 + pp^2)/(4*p*pp))*Log[(p + pp)^2/(p - pp)^2] - 1);
E1log[p_, pp_, e_] := E11[p, pp, e]*-2*
    (((pp^2 - e)*Log[pp^2 - e] - (p^2 - e)*Log[p^2 - e])/(pp^2 - p^2));
(*--#] *)
(*--#[ General*definitions*for*the*matching*correction *)

S[a_, n_] := Sum[1/k^a, {k, 1, n}];
(*--#] *)
(*--#[ The Green function \hat{G}(rh;Eh) *)

GGr[r_, e_] := (Exp[(-Sqrt[-e])*r]/r)*Gamma[1 - CF/(2*Sqrt[-e])]*
    HypergeometricU[-CF/(2*Sqrt[-e]), 0, 2*Sqrt[-e]*r];
GGr0[r_, e_] := Exp[(-Sqrt[-e])*r]/r;
GGrg0[r_, e_] := GGr[r, e] - GGr0[r, e];

SubGGm0[r_, e_] := CF*(Log[2*y] - 1/2 + EulerGamma + PolyGamma[0, 1 - LL]) /. \
    {y -> Sqrt[-e], LL -> CF/(2*Sqrt[-e])};
GGm0subex[r_, e_] := GGrg0[r, e] + SubGGm0[r, e];

GGm0subas[r_, e_] := (-(2/3))*(-1 + 2*EulerGamma + 2*Log[r]) +
   (2/9)*r*(-10 + 3*Sqrt[-e] + 8*EulerGamma + 4*Log[2*Sqrt[-e]] + 4*Log[r] +
     4*PolyGamma[0, 1 - 2/(3*Sqrt[-e])]) +
   (2*r^2*(-160*Sqrt[-e] - 324*(-e)^(5/2) - 756*e + 954*Sqrt[-e]*e +
      486*e^2 + 96*Sqrt[-e]*EulerGamma + 540*(-e)^(3/2)*EulerGamma +
      486*(-e)^(5/2)*EulerGamma + 432*e*EulerGamma - 486*e^2*EulerGamma +
      3*(-8 + 9*e)*(-2*Sqrt[-e] + 9*(-1 + Sqrt[-e])*e)*Log[2*Sqrt[-e]] +
      48*Sqrt[-e]*Log[r] + 270*(-e)^(3/2)*Log[r] + 243*(-e)^(5/2)*Log[r] +
      216*e*Log[r] - 243*e^2*Log[r] + 3*(-8 + 9*e)*(-2*Sqrt[-e] +
        9*(-1 + Sqrt[-e])*e)*PolyGamma[0, 1 - 2/(3*Sqrt[-e])]))/
    (243*(-2*Sqrt[-e] + 9*(-1 + Sqrt[-e])*e)) +
   (r^3*(752 - 6912*Sqrt[-e] - 64881*(-e)^(5/2) - 22320*e +
      41148*Sqrt[-e]*e + 68445*e^2 - 13122*e^3 - 384*EulerGamma +
      3456*Sqrt[-e]*EulerGamma + 23328*(-e)^(3/2)*EulerGamma +
      34992*(-e)^(5/2)*EulerGamma + 11232*e*EulerGamma -
      42768*e^2*EulerGamma + 24*(-2 + 9*e)*(4 - 36*Sqrt[-e] - 99*e +
        81*Sqrt[-e]*e)*Log[2*Sqrt[-e]] - 192*Log[r] + 1728*Sqrt[-e]*Log[r] +
      11664*(-e)^(3/2)*Log[r] + 17496*(-e)^(5/2)*Log[r] + 5616*e*Log[r] -
      21384*e^2*Log[r] + 24*(-2 + 9*e)*(4 - 36*Sqrt[-e] +
        9*(-11 + 9*Sqrt[-e])*e)*PolyGamma[0, 1 - 2/(3*Sqrt[-e])]))/
    (2187*(-4 + 36*Sqrt[-e] + 81*(-e)^(3/2) + 99*e))

GGm0sub[r_, e_] := If[Re[r] > 10^(-7), GGm0subex[r, e], GGm0subas[r, e]];

Rc[r_, e_] := -(CA*((CF - CA/2)/4)*-2*(Exp[(-Sqrt[-e])*r]/r));
Rlog[r_, e_] := Rc[r, e]*(2*Log[Exp[EulerGamma]*r] + 2 + 2*Log[2]);
RcVNA0[r_, e_] := -(CA*(CF/4)*6*(Exp[(-Sqrt[-e])*r]/r));
RlogVNA0[r_, e_] := RcVNA0[r, e]*(2*Log[Exp[EulerGamma]*r] - 2/3 + 2*Log[2]);

RcNANA[r_, e_] := -((CA/2)^2*(Exp[(-Sqrt[-e])*r]/r));
RlogNANA[r_, e_] := RcNANA[r, e]*(2*Log[Exp[EulerGamma]*r] - 1 + 2*Log[2]);
(*--#] *)
(*--#[ Fourier*transforms*of*potentials *)

gp0[1, r_] := 1/(4*Pi*r);
gp1[1, r_] := (-2/(4*Pi*r))*(Log[r] + EulerGamma);
gp0[1/2, r_] := 1/(2*Pi^2*r^2);
gp1[1/2, r_] := (-(Pi^2*r^2)^(-1))*(Log[r] + EulerGamma);
(*--#] *)

(* US*Specific*terms *)

(*--#[ I*all *)

BB[typeI, all][e_] := Module[{expr}, alldGg2single[EE_, n_, smax_] :=
     dG00g2single[EE, n] + 2*dG01g2singleAS[EE, n] + dG11g2singleASv[EE, n] +
      2*dG02g2single[EE, n, smax] + 2*dG12g2single[EE, n, smax] +
      dG22g2single[EE, n, smax]; nmax = 9; Off[NIntegrate::slwcon];
    Off[NIntegrate::ncvb]; expr1 = Table[{n, alldGg2single[e, n, 20]},
      {n, 0, nmax}]; expr2 = Table[{1/(n + 1), Sum[expr1[[nn + 1,2]],
        {nn, 0, n}]}, {n, 0, nmax}]; On[NIntegrate::slwcon];
    On[NIntegrate::ncvb]; expr = Fit[expr2, {1, n}, n]; expr /. n -> 0]

BBdp[typeI, all][np_] := Module[{expr},
   dGdpg2single[npole_, n_] := CF*(CFmCA2^2/(8*npole))*
      NIntegrate[Intdpg2[npole, n, v], {v, 0, 0.01, 0.99, 1}];
    dGdpg2[npole_, nmax_] := Sum[dGdpg2single[npole, n], {n, 0, nmax}];
    dp = dGdpg2[np, 50*16]; (2/3)*(2/np)*dp]

BBsp[typeI, all][np_] := Module[{expr},
   dGdpg2single[npole_, n_] := CF*(CFmCA2^2/(8*npole))*
      NIntegrate[Intdpg2[npole, n, v], {v, 0, 0.01, 0.99, 1}];
    dGdpg2[npole_, nmax_] := Sum[dGdpg2single[npole, n], {n, 0, nmax}];
    dGspg2term1alt[npole_, nmax_] := CF*(CFmCA2^2/(8*npole))*
      NIntegrate[Sum[Intspg2term1alt[npole, n, v], {n, 0, nmax}],
       {v, 0, 0.01, 0.05, 0.3, 0.99, 0.9999, 1}];
    dGspg2term2alt[npole_, nmax_, smax_] := CF*(CFmCA2^2/(8*npole))*
      NIntegrate[Sum[Intspg2term2alt[npole, n, v, smax], {n, 0, nmax}],
       {v, 0, 0.01, 0.05, 0.3, 0.99, 0.9999, 1}]; Off[NIntegrate::slwcon];
    Off[NIntegrate::ncvb]; sp = dGspg2term1alt[np, 24] +
      dGspg2term2alt[np, 24, 30]; On[NIntegrate::slwcon];
    On[NIntegrate::ncvb]; dp = dGdpg2[np, 50*24]; (2/3)*(sp + 3*(dp/np))]
(*--#] *)
(*--#[ IIA*0*ex*(NANA + VNA + VV*combined) *)

(*
Note*the*following*has*been*modified*from*typeIIA . nb*to*account*for*a*
   different*subtraction*in*the*VNA*term . See*notes*p . \
38.*The*modification*
   amounts*to*ANA[p, e, g1] -> ANA[p, e, g0]*in*the*second
term
*)

AA[IIA, ex0][e_, pmax_] :=
  Chop[NIntegrate[Im[p^2*(AV[p, e, g1]^2 + 2*AV[p, e, g1]*ANA[p, e, g0] +
       ANA[p, e, g0]^2)*E01[p, e]], {p, 0, 10, 10^2, 10^3, 10^4, 10^5, 10^6,
     10^7, pmax}]]
BB[IIA, ex0][e_, pmax_] :=
  Chop[NIntegrate[Im[p^2*(AV[p, e, g1]^2 + 2*AV[p, e, g1]*ANA[p, e, g0] +
       ANA[p, e, g0]^2)*E0log[p, e]], {p, 0, 10, 10^2, 10^3, 10^4, 10^5,
     10^6, 10^7, 10^8, pmax}]]

AAdp[IIA, ex0][npole_] := Module[{},
   f0ex[const, p_] := Simplify[
      Series[p^2*(AVpole[p, npole, all] + ANApole[p, npole, all])^2*
        E01[p, -CF^2/(4*(npole - epl)^2)], {epl, 0, -2}]];
    f0exdp[p_] := Coefficient[f0ex[const, p], epl, -2];
    dp = Chop[NIntegrate[f0exdp[p], {p, 0, 1, 10, 10^2, 10^3, 10^4, 10^5,
        10^6, 10^7, 10^8}]]; Expand[(2/3)*(2/npole)*dp]]
BBdp[IIA, ex0][npole_] := Module[{},
   f0ex[log, p_] := Simplify[Series[p^2*(AVpole[p, npole, all] +
          ANApole[p, npole, all])^2*E0log[p, -CF^2/(4*(npole - epl)^2)],
       {epl, 0, -2}]]; f0exdp[p_] := Coefficient[f0ex[log, p], epl, -2];
    dp = Chop[NIntegrate[f0exdp[p], {p, 0, 1, 10, 10^2, 10^3, 10^4, 10^5,
        10^6, 10^7, 10^8}]]; Expand[(2/3)*(2/npole)*dp]]

AAsp[IIA, ex0][npole_] := Module[{},
   sub0[p_] := AVpole[p, npole, g1]^2 + 2*AVpole[p, npole, g1]*
       ANApole[p, npole, g0] + ANApole[p, npole, g0]^2;
    f0ex[p_] := Simplify[Series[p^2*sub0[p]*
        E01[p, -CF^2/(4*(npole - epl)^2)], {epl, 0, -1}]];
    f0exdp[p_] := Coefficient[f0ex[p], epl, -2];
    f0exsp[p_] = Simplify[Coefficient[f0ex[p], epl, -1]];
    dp = Chop[NIntegrate[Re[f0exdp[p]], {p, 0, 10, 10^2, 10^3, 10^4, 10^5,
        10^6, 10^7, 10^8}]]; sp = Chop[NIntegrate[Re[f0exsp[p]],
       {p, 0, 1, 10, 10^2, 10^3, 10^4, 10^5, 10^6, 10^7, 10^8}]];
    Expand[(2/3)*(sp + 3*(dp/npole))]]
BBsp[IIA, ex0][npole_] := Module[{},
   sub0[p_] := AVpole[p, npole, g1]^2 + 2*AVpole[p, npole, g1]*
       ANApole[p, npole, g0] + ANApole[p, npole, g0]^2;
    f0ex[p_] := Simplify[Series[p^2*sub0[p]*E0log[p,
         -CF^2/(4*(npole - epl)^2)], {epl, 0, -1}]];
    f0exdp[p_] := Coefficient[f0ex[p], epl, -2];
    f0exsp[p_] = Simplify[Coefficient[f0ex[p], epl, -1]];
    dp = Chop[NIntegrate[Re[f0exdp[p]], {p, 0, 10, 10^2, 10^3, 10^4, 10^5,
        10^6, 10^7, 10^8}]]; sp = Chop[NIntegrate[Re[f0exsp[p]],
       {p, 0, 1, 10, 10^2, 10^3, 10^4, 10^5, 10^6, 10^7, 10^8}]];
    Expand[(2/3)*(sp + 3*(dp/npole))]]
(*--#] *)
(*--#[ IIA*1*ex*(NANA + VNA + VV*combined), ex*IIA*(NANA + VNA + combined*VV) *)

AA[IIA, ex1][e_, qmax_] := Module[{},
   int1[ee_, q1_, q2_] := Im[p*pp*(AV[p, ee, g1]*AV[pp, ee, g1] +
         AV[p, ee, g0]*ANA[pp, ee, g0] + AV[pp, ee, g0]*ANA[p, ee, g0] +
         ANA[p, ee, all]*ANA[pp, ee, all])*E11[p, pp, ee] /.
       {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}]; Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[q1*int1[e, q1, x*q1], {q1, 10^(-5), 0.01, 10,
        10^3, 10^5, qmax}, {x, 10^(-7), 1}]]; On[NIntegrate::slwcon]; expr]
BB[IIA, ex1][e_, qmax_] := Module[{},
   intlog[ee_, q1_, q2_] := Im[p*pp*(AV[p, ee, g1]*AV[pp, ee, g1] +
         AV[p, ee, g0]*ANA[pp, ee, g0] + AV[pp, ee, g0]*ANA[p, ee, g0] +
         ANA[p, ee, all]*ANA[pp, ee, all])*E1log[p, pp, ee] /.
       {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}]; Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[q1*intlog[e, q1, x*q1], {q1, 10^(-5), 0.1, 10,
        10^3, 10^5, qmax}, {x, 10^(-7), 1}]]; On[NIntegrate::slwcon]; expr]

AAdp[IIA, ex1][npole_] := Module[{},
   f1ex[p_, pp_] := Simplify[Series[p*pp*(AVpole[p, npole, all] +
         ANApole[p, npole, all])*(AVpole[pp, npole, all] +
         ANApole[pp, npole, all])*E11[p, pp, -CF^2/(4*(npole - epl)^2)],
       {epl, 0, -2}]]; f1exdp[p_, pp] := Coefficient[f1ex[p, pp], epl, -2];
    int1dp[q1_, q2_] := f1exdp[p, pp] /. {p -> (q1 + q2)/2,
       pp -> (q1 - q2)/2}; dp = Chop[NIntegrate[q1*int1dp[q1, x*q1],
       {q1, 10^(-6), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, 10^7, 10^8},
       {x, 10^(-7), 1}]]; Expand[(2/3)*(2/npole)*dp]]
BBdp[IIA, ex1][npole_] := Module[{},
   f1ex[p_, pp_] := Simplify[Series[p*pp*(AVpole[p, npole, all] +
         ANApole[p, npole, all])*(AVpole[pp, npole, all] +
         ANApole[pp, npole, all])*E1log[p, pp, -CF^2/(4*(npole - epl)^2)],
       {epl, 0, -2}]]; f1exdp[p_, pp] := Coefficient[f1ex[p, pp], epl, -2];
    int1dp[q1_, q2_] := f1exdp[p, pp] /. {p -> (q1 + q2)/2,
       pp -> (q1 - q2)/2}; dp = Chop[NIntegrate[q1*int1dp[q1, x*q1],
       {q1, 10^(-6), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, 10^7, 10^8},
       {x, 10^(-7), 1}]]; Expand[(2/3)*(2/npole)*dp]]

AAsp[IIA, ex1][npole_] := Module[{},
    sub1[p_, pp_] := AVpole[p, npole, g1]*AVpole[pp, npole, g1] +
       AVpole[p, npole, g0]*ANApole[pp, npole, g0] +
       AVpole[pp, npole, g0]*ANApole[p, npole, g0] +
       ANApole[p, npole, all]*ANApole[pp, npole, all]; f1ex[p_, pp_] :=
     Simplify[Series[p*pp*sub1[p, pp]*E11[p, pp, -CF^2/(4*(npole - epl)^2)],
      {epl, 0, -1}]];
     f1exdp[p_, pp_] = Coefficient[f1ex[p, pp], epl, -2];
     f1exsp[p_, pp_] = Simplify[Coefficient[f1ex[p, pp], epl, -1]];
     int1dp[q1_, q2_] := Re[f1exdp[p, pp]] /. {p -> (q1 + q2)/2,
       pp -> (q1 - q2)/2}; dp = Chop[NIntegrate[q1*int1dp[q1, x*q1],
      {q1, 10^(-5), 1, 10, 10^2, 10^3, 10^4, 10^5, 10^7},
     {x, 10^(-7), 1}]];
     int1sp[q1_, q2_] := Re[f1exsp[p, pp]] /. {p -> (q1 + q2)/2,
       pp -> (q1 - q2)/2}; sp = Chop[NIntegrate[Chop[N[q1*int1sp[q1, x*q1]]],
       {q1, 10^(-5), 1, 10, 10^2, 10^3, 10^4, 10^5, 10^6, 10^7, 10^8},
       {x, 10^(-7), 1}]]; Expand[(2/3)*(sp + 3*(dp/npole))]]
BBsp[IIA, ex1][npole_] := Module[{},
   sub1[p_, pp_] := AVpole[p, npole, g1]*AVpole[pp, npole, g1] +
      AVpole[p, npole, g0]*ANApole[pp, npole, g0] + AVpole[pp, npole, g0]*
       ANApole[p, npole, g0] + ANApole[p, npole, all]*
       ANApole[pp, npole, all]; f1ex[p_, pp_] :=
     Simplify[Series[p*pp*sub1[p, pp]*E1log[p, pp,
         -CF^2/(4*(npole - epl)^2)], {epl, 0, -1}]];
    f1exdp[p_, pp_] = Coefficient[f1ex[p, pp], epl, -2];
    f1exsp[p_, pp_] = Simplify[Coefficient[f1ex[p, pp], epl, -1]];
    int1dp[q1_, q2_] := Re[f1exdp[p, pp]] /. {p -> (q1 + q2)/2,
       pp -> (q1 - q2)/2}; dp = Chop[NIntegrate[q1*int1dp[q1, x*q1],
       {q1, 10^(-5), 1, 10, 10^2, 10^3, 10^4, 10^5, 10^7}, {x, 10^(-7), 1}]];
    int1sp[q1_, q2_] := Re[f1exsp[p, pp]] /. {p -> (q1 + q2)/2,
       pp -> (q1 - q2)/2}; sp = Chop[NIntegrate[Chop[N[q1*int1sp[q1, x*q1]]],
       {q1, 10^(-5), 1, 10, 10^2, 10^3, 10^4, 10^5, 10^6, 10^7, 10^8},
       {x, 10^(-7), 1}]]; Expand[(2/3)*(sp + 3*(dp/npole))]]
(*--#] *)
(*--#[ IIA 1ex  (VV, term 5b) *)

AA[IIA, term5b][e_, qmax_] := Module[{},
   AtermInt[ee_, q1_, q2_] := Im[p*pp*AV1[p, ee]*AV[pp, ee, g1]*
        E11[p, pp, ee] /. {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
    Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[(1/2)*q1*AtermInt[e, q1, x*q1],
       {q1, 10^(-6), 10^(-4), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, qmax},
       {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 1}]]; On[NIntegrate::slwcon];
    expr]
BB[IIA, term5b][e_, qmax_] := Module[{},
   BtermInt[ee_, q1_, q2_] := Im[p*pp*AV1[p, ee]*AV[pp, ee, g1]*
        E1log[p, pp, ee] /. {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
    Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[(1/2)*q1*BtermInt[e, q1, x*q1],
       {q1, 10^(-6), 10^(-4), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, qmax},
       {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 1}]]; On[NIntegrate::slwcon];
    expr]

AAsp[IIA, term5b][npole_, qmax_] :=
  Module[{}, AtermInt[nn_, q1_, q2_] := p1*p2*AV1[p1, -CF^2/(4*nn^2)]*
       ResidAV[p2, nn]*E11[p1, p2, -CF^2/(4*nn^2)] /.
      {p1 -> (q1 + q2)/2, p2 -> (q1 - q2)/2};
    sp = Chop[NIntegrate[(1/2)*q1*AtermInt[npole, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
    Expand[(2/3)*sp]]
BBsp[IIA, term5b][npole_, qmax_] :=
  Module[{}, BtermInt[nn_, q1_, q2_] := p1*p2*AV1[p1, -CF^2/(4*nn^2)]*
       ResidAV[p2, nn]*E1log[p1, p2, -CF^2/(4*nn^2)] /.
      {p1 -> (q1 + q2)/2, p2 -> (q1 - q2)/2};
    sp = Chop[NIntegrate[(1/2)*q1*BtermInt[npole, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
    Expand[(2/3)*sp]]
(*--#] *)
(*--#[ Match term1 (a+b, 1/q^2 potential) *)
(*
From p .37 the coefficient is 1/6 as^4 CF CA^3. The definitions in \
singleinsertion.nb for the 1/q^2 insertion leave out the factor m^2/(4 Pi)^2. \
Thus we need

1/6 as^4 CF CA^3 m^2/(4 Pi)^2 (-1)*Ins2[1,{2,0}e] =
      8/3 gs^2 CF m^2 as^3/(4 Pi)^3*1/16*CA^3 (-1) Ins2[1,{2,0},e]

i.e. we have to multiply by (-1)*CA^3/16 for the Green function. The extra \
(-1) in fron of Ins2[] arises because in the unltrasoft calculation the \
insertion is defined with I*G*deltaV*I*G, while in the single insertion \
calculation of the potential we do NOT include the I^2=-1. Using A and B \
below we also have to include another factor (-a) for 1/(q^2)^(1+a ep) with \
a=2.
In the same units the contribution to the energy level is 4/(3 n)*double pole \
and to |psi (o)|^2 it is
2/3*(single pole+3/n double pole) as before.
*)

AA[match, term1][e_] := -2*-1*(CA^3/16)*
   Chop[NIntegrate[Im[4*Pi*r^2*GGr[r, e]^2*gp0[1, r]],
     {r, 0, 10^(-7), 10^(-5), 10^(-4), 10^(-3), 10^(-2), 10^(-1), 1, 10, 100, \
      10^3, 10^4, 10^5, Infinity}]]
BB[match, term1][e_] := -2*-1*(CA^3/16)*
   Chop[NIntegrate[Im[4*Pi*r^2*GGr[r, e]^2*gp1[1, r]],
     {r, 0, 10^(-7), 10^(-5), 10^(-4), 10^(-3), 10^(-2), 10^(-1), 1, 10, 100, \
      10^3, 10^4, 10^5, Infinity}]]

AAdp[match, term1][npole_] := Module[{}, dp = n /. n -> npole;
    -2*-1*(CA^3/16)*Expand[(2/3)*(2/npole)*dp]]
BBdp[match, term1][npole_] := Module[{},
   dp = -(2*n*(-Log[CF/n] + S[1, n - 1] + 1/n)) /. n -> npole;
    -2*-1*(CA^3/16)*Expand[(2/3)*(2/npole)*dp]]

AAsp[match, term1][npole_] := Module[{}, dp = n /. n -> npole; sp = 0;
    -2*-1*(CA^3/16)*Expand[(2/3)*(sp + 3*(dp/npole))]]
BBsp[match, term1][npole_] := Module[{},
   dp = -(2*n*(-Log[CF/n] + S[1, n - 1] + 1/n)) /. n -> npole;
    sp = -(4*(n*S[2, n - 1] - S[1, n - 1] - n*(Pi^2/6) - 1/2)) /. n -> npole; \
    -2*-1*(CA^3/16)*Expand[(2/3)*(sp + 3*(dp/npole))]]
(*--#] *)
(*--#[ Match term2 (a+b+c, 1/(mq) potential) *)
(*
We use the second option on p .43, i.e. the counterterms are added before \
using the equation of motion. Thus from p .42 the coefficient is

1/3 Pi as^3/m*1/ep*CF*CC,   CC=CA^2 (2+ep [1+4 Ln2])+CF CA (4+ep [-8+8 Ln2])

The definitions in singleinsertion.nb for the 1/(mq) insertion leave out the \
factor m^3 as/(4 Pi). Thus we need

1/3 Pi as^3/m 1/ep*CF*m^3as/(4 Pi) (-1)*Ins2[1/2,{1,0},{coeffs of CC},e] =
      8/3 gs^2 CF m^2 as^3/(4 Pi)^3* Pi^2/(2 ep)*(-1)*Ins2[1/2,{1,0},{coeffs \
of CC},e]

i.e. we have to multiply by (-1)*Pi^2/(2 ep) for the Green function and \
insert CC correctly. The extra (-1) in fron of Ins2[] arises because in the \
unltrasoft calculation the insertion is defined with I*G*deltaV*I*G, while in \
the single insertion calculation of the potential we do NOT include the \
I^2=-1.
In the same units the contribution to the energy level is 4/(3 n)*double pole \
and to |psi (o)|^2 it is
2/3*(single pole+3/n double pole) as before.
*)

AAandBB[match, term2][e_] := Module[{expr},
   AA[1/2, term1, ee_] := Re[NIntegrate[Im[r^2*GGrg0[r, ee]^2*gp0[1/2, r]],
       {r, 0, 10^(-7), 10^(-5), 10^(-4), 10^(-3), 10^(-2), 10^(-1), 1, 10,
        100, 10^3, 10^4, 10^5, Infinity}]]; BB[1/2, term1, ee_] :=
     Re[NIntegrate[Im[r^2*GGrg0[r, ee]^2*gp1[1/2, r]],
       {r, 0, 10^(-7), 10^(-5), 10^(-4), 10^(-3), 10^(-2), 10^(-1), 1, 10,
        100, 10^3, 10^4, 10^5, Infinity}]]; Ins[1/2, a_, ee_] :=
     AA[1/2, term1, ee] - a*ep*(AA[1/2, term1, ee]*LL +
         BB[1/2, term1, ee]) /. LL -> 2*L[m*(as/muP)]; r0 = CA^2*2 + CF*CA*4;

    r1 = CA^2*(1 + 4*Log[2]) + CF*CA*(-8 + 8*Log[2]);
    expr = (r0/ep + r1)*Ins[1/2, 1, e] - (r0/ep)*Ins[1/2, 0, e];
    expr = Expand[-((Pi^2/2)*Normal[Simplify[Series[expr, {ep, 0, 0}]]]) /.
       Log[4] -> 2*Log[2]]]

AAandBBdp[match, term2][n_] := Module[{expr, aa, bb},
   aa = CF/(2*Pi^2); bb = (CF/Pi^2)*(-1 + S[1, n] - Log[n/CF]);
    Ins[1/2, a_] := aa - a*ep*(aa*LL + bb) /. LL -> 2*L[m*(as/muP)];
    r0 = CA^2*2 + CF*CA*4; r1 = CA^2*(1 + 4*Log[2]) + CF*CA*(-8 + 8*Log[2]);
    expr = (r0/ep + r1)*Ins[1/2, 1] - (r0/ep)*Ins[1/2, 0];
    dp = Expand[-((Pi^2/2)*Normal[Simplify[Series[expr, {ep, 0, 0}]]]) /.
       Log[4] -> 2*Log[2]]; Expand[(2/3)*(2/n)*dp]]
AAandBBsp[match, term2][n_] := Module[{expr, aa, bb},
   aadp = CF/(2*Pi^2); bbdp = (CF/Pi^2)*(-1 + S[1, n] - Log[n/CF]);
    aasp = (CF/Pi^2)*(1/(2*n)); bbsp = (CF/Pi^2)*(Pi^2/3 + S[1, n]/n -
       (1/n)*Log[n/CF]); aa = (2/3)*(aasp + 3*(aadp/n));
    bb = (2/3)*(bbsp + 3*(bbdp/n)); Ins[1/2, a_] :=
     aa - a*ep*(aa*LL + bb) /. LL -> 2*L[m*(as/muP)]; r0 = CA^2*2 + CF*CA*4;
    r1 = CA^2*(1 + 4*Log[2]) + CF*CA*(-8 + 8*Log[2]);
    expr = (r0/ep + r1)*Ins[1/2, 1] - (r0/ep)*Ins[1/2, 0];
    Expand[-((Pi^2/2)*Normal[Simplify[Series[expr, {ep, 0, 0}]]]) /.
      Log[4] -> 2*Log[2]]]
(*--#] *)
(*--#[ NANA*term*1 *)
(* p .47*and*52 *)

AA[NANA, term1][e_, pmax_] := Module[{},
   FcNANA[p_, ee_] := (-Pi^(-1))*(CA/2)*If[Re[p] > 10^(-6),
       (p^2 - ee)*ArcTan[p/Sqrt[-ee]] - p*Sqrt[-ee],
       -((2*Sqrt[-ee]*p^3)/(3*ee)) - (2*Sqrt[-ee]*p^5)/(15*ee^2) -
        (2*Sqrt[-ee]*p^7)/(35*ee^3) - (2*Sqrt[-ee]*p^9)/(63*ee^4) -
        (2*Sqrt[-ee]*p^11)/(99*ee^5)];
    Re[NIntegrate[Im[FcNANA[p, e]*(ANAsub2[p, e] + (CA/2)*2*(-CF/p^3)*
          (-Log[p]))], {p, 0, 1, 10, 100, 10^3, 10^4, 10^5, pmax}]]]
BB[NANA, term1][e_, pmax_] := Module[{},
   FcNANA[p_, ee_] := (-Pi^(-1))*(CA/2)*If[Re[p] > 10^(-6),
       (p^2 - ee)*ArcTan[p/Sqrt[-ee]] - p*Sqrt[-ee],
       -((2*Sqrt[-ee]*p^3)/(3*ee)) - (2*Sqrt[-ee]*p^5)/(15*ee^2) -
        (2*Sqrt[-ee]*p^7)/(35*ee^3) - (2*Sqrt[-ee]*p^9)/(63*ee^4) -
        (2*Sqrt[-ee]*p^11)/(99*ee^5)]; FlogNANA[p_, ee_] :=
     FcNANA[p, ee]*-2*Log[p^2 - ee];
    Re[NIntegrate[Im[FlogNANA[p, e]*(ANAsub2[p, e] + (CA/2)*2*(-CF/p^3)*
          (-Log[p]))], {p, 0, 1, 10, 100, 10^3, 10^4, 10^5, pmax}]]]

NANAterm1IntEx[pp_, nn_] := Module[{expr1},
   expr1 = (1/(2*I*p^2))*(1 - znp^n - (1 - znm^n)) -
      (1/(2*(CF/n)*p))*(n*(znp^(n - 1)/xnp^2) + n*(znm^(n - 1)/xnm^2));
    (-Pi^(-1))*(CA/2)^2*((p^2 + CF^2/(4*nn^2))*ArcTan[p/(CF/(2*nn))] -
       (CF/(2*nn))*p)*(expr1 - 2*(CF/pp^3)) /. {n -> nn, p -> pp}]
NANAterm1IntSmall[pp_, nn_] := (6*nn)/Pi - (27*nn^3*pp^2)/(10*Pi) +
    (81*nn^5*(9 + 35*(-1)^nn + 70*(-1)^nn*nn^2)*pp^4)/(280*Pi) -
    (729*nn^7*(5 + 49*(-1)^nn + 154*(-1)^nn*nn^2 + 28*(-1)^nn*nn^4)*pp^6)/
     (1120*Pi) + (1/(246400*Pi))*(6561*nn^9*(175 + 3102*(-1)^nn +
       12650*(-1)^nn*nn^2 + 4158*(-1)^nn*nn^4 + 220*(-1)^nn*nn^6)*pp^8);
NANAterm1IntLarge[pp_, nn_] :=
   (4096*(2169 + 13355*nn^2 + 7686*nn^4 + 930*nn^6 + 25*nn^8))/
     (93002175*nn^9*Pi*pp^10) -
    (256*(-45 + 1124*nn^2 + 1470*nn^4 + 276*nn^6 + 10*nn^8))/
     (6200145*nn^8*pp^9) - (512*(103 + 546*nn^2 + 238*nn^4 + 16*nn^6))/
     (229635*nn^7*Pi*pp^8) + (64*(-9 + 154*nn^2 + 154*nn^4 + 16*nn^6))/
     (76545*nn^6*pp^7) + (128*(17 + 70*nn^2 + 18*nn^4))/(3645*nn^5*Pi*pp^6) - \
    (16*(-1 + 10*nn^2 + 6*nn^4))/(405*nn^4*pp^5) -
    (64*(1 + 2*nn^2))/(27*nn^3*Pi*pp^4) + (8*(2 + 1/nn^2))/(9*pp^3);
NANAterm1Int[pp_, nn_] := Re[If[pp < 10^(-4), NANAterm1IntSmall[pp, nn],
    If[pp > 10^5, NANAterm1IntLarge[pp, nn], NANAterm1IntEx[pp, nn]]]]

AAsp[NANA, term1][np_] := (2/3)*NIntegrate[NANAterm1Int[pp, np],
     {pp, 0, 10^(-4), 1, 10, 10^5, Infinity}];
BBsp[NANA, term1][np_] := (2/3)*NIntegrate[NANAterm1Int[pp, np]*-2*
      Log[pp^2 + CF^2/(4*np^2)], {pp, 0, 10^(-4), 1, 10, 10^5, Infinity}];
(*--#] *)
(*--#[ NANA*term*2 *)
(* yk corrected line break of IntNANA2[], where * was missing
after  1/(1953045675*nn^8) *)
(* p .48 *)

AA[NANA, term2][e_] := Re[NIntegrate[Im[RcNANA[r, e]*GGm0sub[r, e]],
    {r, 0, 10^(-5), 10^(-4), 10^(-3), 10^(-2), 10^(-1), 1, 10, 100, 10^3,
     10^4, 10^5, Infinity}]]
BB[NANA, term2][e_] := Re[NIntegrate[Im[RlogNANA[r, e]*GGm0sub[r, e]],
    {r, 0, 10^(-5), 10^(-4), 10^(-3), 10^(-2), 10^(-1), 1, 10, 100, 10^3,
     10^4, 10^5, Infinity}]]

IntExNANA2[rh_, nn_] := (-(CA/2)^2)*CF*(Exp[(-CF)*(rh/(2*nn))]/rh)*
    (Exp[(-CF)*(rh/(2*nn))]*(LaguerreL[nn - 1, 1, CF*(rh/nn)]/nn) - 1);
IntSmallNANA2[rh_, nn_] := 2 - (2*(1 + 2*nn*(3 + nn))*rh)/(9*nn^2) +
   (4*(3 + nn*(11 + nn*(6 + nn)))*rh^2)/(81*nn^3) -
   (2*(33 + 2*nn*(5 + nn)*(10 + nn*(5 + nn)))*rh^3)/(1215*nn^4) +
   (4*(195 + 2*nn*(274 + nn*(225 + nn*(85 + nn*(15 + nn)))))*rh^4)/
    (54675*nn^5) -
   (4*(2565 + 4*nn*(7 + nn)*(252 + nn*(7 + nn)*(28 + nn*(7 + nn))))*rh^5)/
    (3444525*nn^6) + (1/(72335025*nn^7))*
    (8*(4725 + nn*(13068 + nn*(13132 +
          nn*(6769 + nn*(1960 + nn*(322 + nn*(28 + nn)))))))*rh^6) -
   1/(1953045675*nn^8)*
2*(77805 + 2*nn*(9 + nn)*(12176 + nn*(9 + nn)*
        (1308 + nn*(9 + nn)*(60 + nn*(9 + nn)))))*rh^7 +
   (1/(263661166125*nn^9))*
    (4*(711585 + 2*nn*(1026576 + nn*(1172700 +
          nn*(723680 + nn*(269325 + nn*(63273 + nn*(9450 + nn*(870 +
                    nn*(45 + nn)))))))))*rh^8);
IntNANA2[rh_, nn_] := Re[If[rh < 10^(-5), IntSmallNANA2[rh, nn],
    IntExNANA2[rh, nn]]]

AAsp[NANA, term2][np_] := (2/3)*NIntegrate[IntNANA2[rh, np],
     {rh, 0, 10^(-5), 0.01, 0.1, 1, 10, 100, 10^3}];
BBsp[NANA, term2][np_] := (2/3)*NIntegrate[IntNANA2[rh, np]*
      (2*Log[rh] + 2*EulerGamma - 1 + 2*Log[2]), {rh, 0, 10^(-4), 0.01, 1,
      10, 100, 10^3}];
(*--#] *)
(*--#[ NANA*term*3*and*6, 18*and*NANA*term *)

NANA3loop[e_] := -(7/6) + 9/(8*ep^2) - (43*Pi^2)/32 - 9*L[(as*m)/muP]^2 -
   (5/4)*L[(m*muUS)/muP^2] - (3/4)*L[(m*muUS)/muP^2]^2 +
   2*L[(as*m)/muP]*(-2 + 3*L[(m*muUS)/muP^2]) +
   (25/8 - (3/4)*L[(m*muUS)/muP^2] - (9*Log[2])/4)/ep - (19*Log[2])/4 +
   (3/2)*L[(m*muUS)/muP^2]*Log[2] + (9*Log[2]^2)/4 +
   (-2 - 9*L[(as*m)/muP] + 3*L[(m*muUS)/muP^2])*Log[-e] - (9/4)*Log[-e]^2

AAandBB[NANA, term3and6][e_] :=
  Module[{}, expr1 = Expand[(1/CF)*(Re[NANA3loop[e]]*"Im[Ghat(0,e)]" +
         Im[NANA3loop[e]]*ReGhat[e]) //. ComplexSimplify];
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2] +
      (1/ep)*Coefficient[expr1, ep, -1] + (Coefficient[expr1, ep, 0] /.
       "Im[Ghat(0,e)]" -> ImGhat[e])]

AAandBBsp[NANA, term3and6][n_] :=
  Module[{}, expr1 = (1/CF)*(NANA3loop[e] /. e -> -CF^2/(4*n^2));
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2]*"[Ghat(0,Eh)]" +
       (1/ep)*Coefficient[expr1, ep, -1]*"[Ghat(0,Eh)]" +
       Simplify[CF*Coefficient[expr1, ep, 0]] //. Log2s; expr = (2/3)*expr2]
(*--#] *)
(*--#[ NANA*term*4 *)
(* p .55 *)

JcNANA[p_, e_] := (-Pi^(-1))*(CA/2)^2*p^2*(p^2 - e);
AANANA2[p_, e_] := (1/p)*((1/p)*ArcTan[p/Sqrt[-e]] - Sqrt[-e]/(p^2 - e));
Sub0NANA2[p_, e_] := -2*(Sqrt[-e]/p^3);
IntNANA4Ex[p_, e_] := JcNANA[p, e]*((AANANA2[p, e] - Sub0NANA2[p, e])^2 -
     Sub0NANA2[p, e]^2);
IntNANA4As[p_, e_] := (-3*Sqrt[-e^(-1)]*e^2)/p^3 + (9*e^2)/(p^4*Pi) -
    (9*Pi)/16 + ((-9*e)/Pi + (9*e*Pi)/16)/p^2;
IntNANA4[p_, e_] := If[Re[p] < 10^6, IntNANA4Ex[p, e], IntNANA4As[p, e]];

AA[NANA, term4][e_] := Re[NIntegrate[Im[IntNANA4[p, e]],
     {p, 0, 1, 10, 100, 10^3, 10^4, 10^5, 10^6, 10^7, Infinity}]];
BB[NANA, term4][e_] := Re[NIntegrate[Im[-2*Log[p^2 - e]*IntNANA4[p, e]],
     {p, 0, 1, 10, 100, 10^3, 10^4, 10^5, 10^6, 10^7, Infinity}]];
(*--#] *)
(*--#[ NANA*term*5 *)
(* p .55 *)

AAandBB[NANA, term5][e_] :=
   Expand[-((CA/2)^2*(Im[y]*((-2 + 2*Log[2])*-2*L[m*(as/muP)]) +
        Im[2*Sqrt[-e]*((-1 + Log[2])*-2*Log[Sqrt[-e]] - 1 - Log[2] +
           Log[2]^2)])) /. y -> Sqrt[-e]];
(*--#] *)
(*--#[ VNA*1*ex*term*1 *)
(
AA[VNA1ex, term1][e_, qmax_] :=
    Module[{},
	   A1termIntEx[ee_, q1_, q2_] :=
	       Im[p*pp*(ANA0y[p, y]*AVy[pp, y, g0] + AV0y[p, y]*(ANAy[pp, y, g0] + SubANA1y[pp, y]))*
		      E11[p, pp, ee] /. {y -> Sqrt[-ee], p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
	   Off[NIntegrate::slwcon];
	   Off[NIntegrate::ncvb];
	   Off[NIntegrate::eincr];
	   expr = Chop[NIntegrate[(1/2)*q1*A1termIntEx[e, q1, x*q1],
				  {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
				   qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
	   On[NIntegrate::slwcon];
	   On[NIntegrate::ncvb];
	   On[NIntegrate::eincr];
	   expr]
)
(
BB[VNA1ex, term1][e_, qmax_] :=
    Module[{},
	   B1termIntEx[ee_, q1_, q2_] :=
	       Im[p*pp*(ANA0y[p, y]*AVy[pp, y, g0] + AV0y[p, y]*(ANAy[pp, y, g0] + SubANA1y[pp, y]))*
		      E1log[p, pp, ee] /. {y -> Sqrt[-ee], p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
	   Off[NIntegrate::slwcon];
	   Off[NIntegrate::ncvb];
	   Off[NIntegrate::eincr];
	   expr = Chop[NIntegrate[(1/2)*q1*B1termIntEx[e, q1, x*q1],
				  {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
				   qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
	   On[NIntegrate::slwcon];
	   On[NIntegrate::ncvb];
	   On[NIntegrate::eincr];
	   expr]
)
(
AAandBB[VNA1ex, term1][e_, qmax_] :=
    Module[{},
	   AandB1termIntEx[ee_, q1_, q2_] :=
	       Im[p*pp*(ANA0y[p, y]*AVy[pp, y, g0] + AV0y[p, y]*(ANAy[pp, y, g0] + SubANA1y[pp, y]))*
		      (E11[p, pp, ee] * (-2*Log[2*Exp[-5/6]]) + E1log[p, pp, ee])
			  /. {y -> Sqrt[-ee], p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
	   Off[NIntegrate::slwcon];
	   Off[NIntegrate::ncvb];
	   Off[NIntegrate::eincr];
	   expr = Chop[NIntegrate[(1/2)*q1*AandB1termIntEx[e, q1, x*q1],
				  {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
				   qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
	   On[NIntegrate::slwcon];
	   On[NIntegrate::ncvb];
	   On[NIntegrate::eincr];
	   expr]
)
AAsp[VNA1ex, term1][n_, qmax_] :=
  Module[{}, AtermIntEx[nn_, q1_, q2_] :=
     p1*p2*(ANA0y[p1, CF/(2*nn)]*ResidVNA1[p2, nn] + AV0y[p1, CF/(2*nn)]*
         ResidVNA2[p2, nn])*E11[p1, p2, -CF^2/(4*nn^2)] /.
      {p1 -> (q1 + q2)/2, p2 -> (q1 - q2)/2}; Off[NIntegrate::slwcon];
    Off[NIntegrate::ncvb];
    expr = Chop[NIntegrate[(1/2)*q1*AtermIntEx[n, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
    On[NIntegrate::slwcon]; On[NIntegrate::ncvb]; (2/3)*expr]
BBsp[VNA1ex, term1][n_, qmax_] :=
  Module[{}, BtermIntEx[nn_, q1_, q2_] :=
     p1*p2*(ANA0y[p1, CF/(2*nn)]*ResidVNA1[p2, nn] + AV0y[p1, CF/(2*nn)]*
         ResidVNA2[p2, nn])*E1log[p1, p2, -CF^2/(4*nn^2)] /.
      {p1 -> (q1 + q2)/2, p2 -> (q1 - q2)/2}; Off[NIntegrate::slwcon];
    Off[NIntegrate::ncvb];
    expr = Chop[NIntegrate[(1/2)*q1*BtermIntEx[n, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
    On[NIntegrate::slwcon]; On[NIntegrate::ncvb]; (2/3)*expr]
(*--#] *)
(*--#[ VNA*1*ex*term*2 *)
(* yk corrected the line break of IntSmallVNA12[]
where * was missing after 1/(651015225*nn^7) *)

AA[VNA1ex, term2][e_] := Re[NIntegrate[Im[Rc[r, e]*GGm0sub[r, e]],
    {r, 0, 10^(-5), 10^(-4), 10^(-3), 10^(-2), 10^(-1), 1, 10, 100, 10^3,
     10^4, 10^5, Infinity}]]
BB[VNA1ex, term2][e_] := Re[NIntegrate[Im[Rlog[r, e]*GGm0sub[r, e]],
    {r, 0, 10^(-5), 10^(-4), 10^(-3), 10^(-2), 10^(-1), 1, 10, 100, 10^3,
     10^4, 10^5, Infinity}]]

IntExVNA12[rh_, nn_] := (-4^(-1))*CF*(Exp[(-CF)*(rh/(2*nn))]/rh)*
    (Exp[(-CF)*(rh/(2*nn))]*(LaguerreL[nn - 1, 1, CF*(rh/nn)]/nn) - 1);
IntSmallVNA12[rh_, nn_] := 2/9 - (2*(1 + 2*nn*(3 + nn))*rh)/(81*nn^2) +
   (4*(3 + nn*(11 + nn*(6 + nn)))*rh^2)/(729*nn^3) -
   (2*(33 + 2*nn*(5 + nn)*(10 + nn*(5 + nn)))*rh^3)/(10935*nn^4) +
   (4*(195 + 2*nn*(274 + nn*(225 + nn*(85 + nn*(15 + nn)))))*rh^4)/
    (492075*nn^5) -
   (4*(2565 + 4*nn*(7 + nn)*(252 + nn*(7 + nn)*(28 + nn*(7 + nn))))*rh^5)/
    (31000725*nn^6) + 1/(651015225*nn^7)*
8*(4725 + nn*(13068 + nn*(13132 +
         nn*(6769 + nn*(1960 + nn*(322 + nn*(28 + nn)))))))*rh^6 -
   (1/(17577411075*nn^8))*
    (2*(77805 + 2*nn*(9 + nn)*(12176 + nn*(9 + nn)*
         (1308 + nn*(9 + nn)*(60 + nn*(9 + nn)))))*rh^7) +
   (1/(2372950495125*nn^9))*
    (4*(711585 + 2*nn*(1026576 + nn*(1172700 +
          nn*(723680 + nn*(269325 + nn*(63273 + nn*(9450 + nn*(870 +
                    nn*(45 + nn)))))))))*rh^8);
IntVNA12[rh_, nn_] := Re[If[rh < 10^(-5), IntSmallVNA12[rh, nn],
    IntExVNA12[rh, nn]]]

AAsp[VNA1ex, term2][n_] := (2/3)*NIntegrate[(CF - CA/2)*CA*-2*
      IntVNA12[rh, n], {rh, 0, 10^(-5), 0.01, 0.1, 1, 10, 100, 10^3}];
BBsp[VNA1ex, term2][n_] := (2/3)*NIntegrate[(CF - CA/2)*CA*IntVNA12[rh, n]*
      (-4*Log[rh] - 4*EulerGamma - 4 - 4*Log[2]), {rh, 0, 10^(-4), 0.01, 1,
      10, 100, 10^3}];
(*--#] *)
(*--#[ VNA*1*ex*term*3*and*6 *)

VNA1ex3loop[e_] := 19/36 - 3/(16*ep^2) + (35*Pi^2)/192 +
   (3/2)*L[(as*m)/muP]^2 + (29/24)*L[(m*muUS)/muP^2] +
   (1/8)*L[(m*muUS)/muP^2]^2 + (5/48 + (1/8)*L[(m*muUS)/muP^2] - Log[2]/8)/
    ep - (73*Log[2])/24 - (5/4)*L[(m*muUS)/muP^2]*Log[2] + (13*Log[2]^2)/8 +
   2*L[(as*m)/muP]*(-(23/12) - (1/2)*L[(m*muUS)/muP^2] + 2*Log[2]) +
   (-(23/12) + (3/2)*L[(as*m)/muP] - (1/2)*L[(m*muUS)/muP^2] + 2*Log[2])*
    Log[-e] + (3/8)*Log[-e]^2

AAandBB[VNA1ex, term3and6][e_] :=
  Module[{},
   expr1 = Expand[CA*(CF - CA/2)*(Re[VNA1ex3loop[e]]*"Im[Ghat(0,e)]" +
         Im[VNA1ex3loop[e]]*ReGhat[e]) //. ComplexSimplify];
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2] +
      (1/ep)*Coefficient[expr1, ep, -1] + (Coefficient[expr1, ep, 0] /.
       "Im[Ghat(0,e)]" -> ImGhat[e])]

AAandBBsp[VNA1ex, term3and6][n_] :=
  Module[{}, expr1 = CA*(CF - CA/2)*(VNA1ex3loop[e] /. e -> -CF^2/(4*n^2));
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2]*"[Ghat(0,Eh)]" +
       (1/ep)*Coefficient[expr1, ep, -1]*"[Ghat(0,Eh)]" +
       Simplify[CF*Coefficient[expr1, ep, 0]] //. Log2s; expr = (2/3)*expr2]
(*--#] *)
(*--#[ VNA*1*ex*term*4 *)

AA[VNA1ex, term4][e_, qmax_] :=
  Module[{}, AtermInt[ee_, q1_, q2_] :=
     Im[p*pp*AV0y[p, y]*2*ANA0sub[pp, y]*E11[p, pp, ee] /.
       {y -> Sqrt[-ee], p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
	 Off[NIntegrate::slwcon]; Off[NIntegrate::ncvb]; Off[NIntegrate::eincr];
    expr = Chop[NIntegrate[(1/2)*q1*AtermInt[e, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 0.999,
        1 - 10^(-6)}]]; On[NIntegrate::slwcon]; On[NIntegrate::ncvb]; On[NIntegrate::eincr]; expr]
BB[VNA1ex, term4][e_, qmax_] :=
  Module[{}, BtermInt[ee_, q1_, q2_] :=
     Im[p*pp*AV0y[p, y]*2*ANA0sub[pp, y]*E1log[p, pp, ee] /.
       {y -> Sqrt[-ee], p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
    Off[NIntegrate::slwcon]; Off[NIntegrate::ncvb]; Off[NIntegrate::eincr];
    expr = Chop[NIntegrate[(1/2)*q1*BtermInt[e, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 0.999,
        1 - 10^(-6)}]]; On[NIntegrate::slwcon]; On[NIntegrate::ncvb]; On[NIntegrate::eincr]; expr]
(*--#] *)
(*--#[ VNA*1*ex*term*5 *)

AAandBB[VNA1ex, term5][e_] :=
   Expand[CA*CFmCA2*(Im[y]*((-(-2 + 2*Log[2]))*L[m*(as/muP)]) +
       Im[y*(-4 + 2*Log[2] + Log[2]^2 - (-2 + 2*Log[2])*Log[y])]) /.
     y -> Sqrt[-e]];
(*--#] *)
(*--#[ VNA*0*ex*term*1 *)

AAminSubLargeVNA0[p_, y_] := Pi/2 - (CF^2*Pi)/(4*p^2) +
   (CF^2*Pi*(2 + CF^2/(4*y^2))*y^2)/(12*p^4) -
   (CF^2*Pi*(23 + CF^4/(8*y^4) + (5*CF^2)/y^2)*y^4)/(180*p^6) +
   (CF/2 - CF*Log[1/p])/p + (1/(9*p^3))*
    (y^3*(3 - (11*CF^3)/(4*y^3) + (3*CF^3*EulerGamma)/(2*y^3) +
      (3*CF^2)/(2*y^2) + CF/(2*y) + (3*CF*EulerGamma)/y +
      6*(CF^3/(4*y^3) + CF/(2*y))*Log[1/p] + (3*CF^3*Log[2*y])/(2*y^3) +
      (3*CF*Log[2*y])/y + 6*(CF^3/(4*y^3) + CF/(2*y))*
       PolyGamma[0, 1 - CF/(2*y)])) - (1/(450*p^5))*
    (y^5*(90 - (137*CF^5)/(16*y^5) + (15*CF^5*EulerGamma)/(4*y^5) +
      (15*CF^4)/(4*y^4) - (445*CF^3)/(4*y^3) + (75*CF^3*EulerGamma)/y^3 +
      (75*CF^2)/y^2 + (99*CF)/(2*y) + (90*CF*EulerGamma)/y +
      (30*CF*(3 + CF^4/(8*y^4) + (5*CF^2)/(2*y^2))*Log[1/p])/y +
      (15*CF^5*Log[2*y])/(4*y^5) + (75*CF^3*Log[2*y])/y^3 +
      (90*CF*Log[2*y])/y + (30*CF*(3 + CF^4/(8*y^4) + (5*CF^2)/(2*y^2))*
        PolyGamma[0, 1 - CF/(2*y)])/y))

ffVNA0[p_, y_] := 2*CA*(CF/Pi)*(p/(p^2 + y^2))*
    (3*Sqrt[y^2] + ((3*p^2 + y^2)/p)*ArcSin[p/Sqrt[p^2 + y^2]]);
fflargeVNA0[p_, y_] := 12 - (8*y^2)/p^2 + (8*y^4)/p^4 - (8*y^6)/p^6 +
    (8*y^8)/p^8 - (32*y^4*Sqrt[y^2])/(15*p^5*Pi) +
    (416*y^6*Sqrt[y^2])/(105*p^7*Pi);

BB[VNA0ex, term1][e_] := Module[{},
   B1IntEx[p_, ee_] := ffVNA0[p, y]*(AAVNA0[p, y] - (1/p)*SubVNA0[y]) /.
      y -> Sqrt[-ee]; B1IntLarge[p_, ee_] :=
     fflargeVNA0[p, y]*AAminSubLargeVNA0[p, y] /. y -> Sqrt[-ee];
    B1Int[p_, ee_] := Im[If[p > 10^4.5, B1IntLarge[p, ee], B1IntEx[p, ee]]];
    NIntegrate[B1Int[p, e], {p, 0, 0.01, 1, 10, 100, 10^3, 10^4.5, 10^6,
      Infinity}]]

BBsp[VNA0ex, term1][np_] := Module[{},
   BIntEx[pp_, nn_] := ffVNA0[p, CF/(2*nn)]*((1/(2*I))*(znm^nn - znp^nn) -
        CF/pp) /. {n -> nn, p -> pp};
    (2/3)*Chop[NIntegrate[BIntEx[pp, np], {pp, 0, Infinity}]]]
(*--#] *)
(*--#[ VNA*0*ex*term*2 *)
(* p .64 *)

VNA0ex3loopA[e_] := 41/3 + 1/ep - 8*L[(as*m)/muP] + 2*L[(m*muUS)/muP^2] -
    (22*Log[2])/3 - 4*Log[-e];

BB[VNA0ex, term2][e_] := Module[{},
   expr1 = Expand[(3/8)*CA*CF*(Re[VNA0ex3loopA[e]]*"Im[Ghat(0,e)]" +
         Im[VNA0ex3loopA[e]]*ReGhat[e]) //. ComplexSimplify];
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2] +
      (1/ep)*Coefficient[expr1, ep, -1] + (Coefficient[expr1, ep, 0] /.
       "Im[Ghat(0,e)]" -> ImGhat[e])]

BBsp[VNA0ex, term2][n_] := Module[{},
   expr1 = (3/8)*CA*CF*(VNA0ex3loopA[e] /. e -> -CF^2/(4*n^2));
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2]*"[Ghat(0,Eh)]" +
       (1/ep)*Coefficient[expr1, ep, -1]*"[Ghat(0,Eh)]" +
       Simplify[CF*Coefficient[expr1, ep, 0]] //. Log2s; expr = (2/3)*expr2]
(*--#] *)
(*--#[ VNA*0*ex*term*3 *)
(* p .65 Factor 2 added, 08.10.07 *)

VNA0ex00[e_] := 2*(47/3 + 1/ep - 8*L[(as*m)/muP\[CapitalGamma]] +
     2*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2] - 10*Log[2] - 4*Log[-e]);

AAandBB[VNA0ex, term3][e_] := Module[{},
   expr1 = Expand[(-CA/4)*(Re[VNA0ex00[e]]*"\[CapitalGamma]t" +
Im[VNA0ex00[e]]*
          Re[e]) //. ComplexSimplify];
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2] +
      (1/ep)*Coefficient[expr1, ep, -1] + (Coefficient[expr1, ep, 0] /.
       "\[CapitalGamma]t" -> Im[e])]
(*--#] *)
(*--#[ VNA*0*ex*term*4 *)
(* p .67*and*76 *)

ff1VNA04[p_, y_] := 2*(ArcSin[p/Sqrt[p^2 + y^2]]/p);
ff2VNA04[p_, y_] := (-2^(-1))*ff1VNA04[p, y] + Sqrt[y^2]/(p^2 + y^2)

AA[VNA0ex, term4][e_, pmax_] :=
  Re[NIntegrate[Im[CA*(CF/Pi)*((-2^(-1))*p^3*ff1VNA04[p, Sqrt[-e]]*
        (ANAsub[p, e]/(CA/2) + 2*(-CF/p^3)*(-Log[p])) +
       p*ff2VNA04[p, Sqrt[-e]]*AAsub[p, e])], {p, 0, 1, 10, 100, 10^3, 10^4,
     10^5, 10^7, pmax}]]

BB[VNA0ex, term4][e_, pmax_] :=
  Re[NIntegrate[Im[CA*(CF/Pi)*((-2^(-1))*p^3*ff1VNA04[p, Sqrt[-e]]*
        (ANAsub[p, e]/(CA/2) + 2*(-CF/p^3)*(-Log[p])) +
       p*ff2VNA04[p, Sqrt[-e]]*AAsub[p, e])*-2*Log[p^2 - e]],
    {p, 0, 1, 10, 100, 10^3, 10^4, 10^5, 10^7, pmax}]]

IntExVNA04[pp_, nn_] := CA*(CF/Pi)*pp*((-2^(-1))*pp^2*ff1VNA04[pp,
CF/(2*nn)]*
       ((1/(2*I*p^2))*(1 - znp^n - (1 - znm^n)) - (1/(2*(CF/n)*p))*
         (n*(znp^(n - 1)/xnp^2) + n*(znm^(n - 1)/xnm^2)) - 2*(CF/pp^3)) +
      ff2VNA04[pp, CF/(2*nn)]*((1/(2*I))*(znm^nn - znp^nn) - CF/pp)) /.
    {n -> nn, p -> pp};
IntSmallVNA04[pp_, nn_] := (16*nn)/Pi +
    (27*nn^5*(-3 + 10*(-1)^nn + 10*(-1)^nn*nn^2)*pp^4)/(5*Pi) -
    (81*nn^7*(-45 + 161*(-1)^nn + 280*(-1)^nn*nn^2 + 42*(-1)^nn*nn^4)*pp^6)/
     (70*Pi) + (2187*nn^9*(-35 + 132*(-1)^nn + 308*(-1)^nn*nn^2 +
       84*(-1)^nn*nn^4 + 4*(-1)^nn*nn^6)*pp^8)/(560*Pi);
IntLargeVNA04[pp_, nn_] := -((4096*(87 + 308*nn^2 + 84*nn^4 + 4*nn^6))/
      (413343*nn^7*Pi*pp^8)) + (512*(45 + 196*nn^2 + 70*nn^4 + 4*nn^6))/
     (76545*nn^6*pp^7) + (8192*(7 + 20*nn^2 + 3*nn^4))/(32805*nn^5*Pi*pp^6) -
    (896*(3 + 10*nn^2 + 2*nn^4))/(3645*nn^4*pp^5) -
    (256*(1/nn^2)^(3/2)*(1 + 2*nn^2))/(81*Pi*pp^4) +
    (160*(1 + 2*nn^2))/(81*nn^2*pp^3);
IntVNA04[pp_, nn_] := If[pp > 10^4.5, IntLargeVNA04[pp, nn],
    If[pp < 10^(-5), IntSmallVNA04[pp, nn], IntExVNA04[pp, nn]]];

AAsp[VNA0ex, term4][np_] := (2/3)*NIntegrate[IntVNA04[pp, np],
     {pp, 0, 10^(-4), 1, 10, 10^5, Infinity}];
BBsp[VNA0ex, term4][np_] := (2/3)*NIntegrate[IntVNA04[pp, np]*-2*
      Log[pp^2 + CF^2/(4*np^2)], {pp, 0, 10^(-4), 1, 10, 10^5, Infinity}];
(*--#] *)
(*--#[ VNA*0*ex*term*5 *)
(* yk corrected line break,
where * was missing after   1/(17577411075*nn^8) *)
(* p .67*and*77 *)

AA[VNA0ex, term5][e_] := Re[NIntegrate[Im[RcVNA0[r, e]*GGm0sub[r, e]],
    {r, 0, 10^(-5), 10^(-4), 10^(-3), 10^(-2), 10^(-1), 1, 10, 100, 10^3,
     10^4, 10^5, Infinity}]]
BB[VNA0ex, term5][e_] := Re[NIntegrate[Im[RlogVNA0[r, e]*GGm0sub[r, e]],
    {r, 0, 10^(-5), 10^(-4), 10^(-3), 10^(-2), 10^(-1), 1, 10, 100, 10^3,
     10^4, 10^5, Infinity}]]

IntExVNA05[rh_, nn_] := (-4^(-1))*CF*(Exp[(-CF)*(rh/(2*nn))]/rh)*
    (Exp[(-CF)*(rh/(2*nn))]*(LaguerreL[nn - 1, 1, CF*(rh/nn)]/nn) - 1);
IntSmallVNA05[rh_, nn_] := 2/9 - (2*(1 + 2*nn*(3 + nn))*rh)/(81*nn^2) +
   (4*(3 + nn*(11 + nn*(6 + nn)))*rh^2)/(729*nn^3) -
   (2*(33 + 2*nn*(5 + nn)*(10 + nn*(5 + nn)))*rh^3)/(10935*nn^4) +
   (4*(195 + 2*nn*(274 + nn*(225 + nn*(85 + nn*(15 + nn)))))*rh^4)/
    (492075*nn^5) -
   (4*(2565 + 4*nn*(7 + nn)*(252 + nn*(7 + nn)*(28 + nn*(7 + nn))))*rh^5)/
    (31000725*nn^6) + (1/(651015225*nn^7))*
    (8*(4725 + nn*(13068 + nn*(13132 +
          nn*(6769 + nn*(1960 + nn*(322 + nn*(28 + nn)))))))*rh^6) -
   1/(17577411075*nn^8)*
2*(77805 + 2*nn*(9 + nn)*(12176 + nn*(9 + nn)*
        (1308 + nn*(9 + nn)*(60 + nn*(9 + nn)))))*rh^7 +
   (1/(2372950495125*nn^9))*
    (4*(711585 + 2*nn*(1026576 + nn*(1172700 +
          nn*(723680 + nn*(269325 + nn*(63273 + nn*(9450 + nn*(870 +
                    nn*(45 + nn)))))))))*rh^8);
IntVNA05[rh_, nn_] := Re[If[rh < 10^(-5), IntSmallVNA05[rh, nn],
    IntExVNA05[rh, nn]]]

AAsp[VNA0ex, term5][nn_] := (2/3)*NIntegrate[CF*CA*6*IntVNA05[rh, nn],
     {rh, 0, 10^(-5), 0.01, 0.1, 1, 10, 100, 10^3}];
BBsp[VNA0ex, term5][nn_] := (2/3)*NIntegrate[CF*CA*IntVNA05[rh, nn]*
      (12*Log[rh] + 12*EulerGamma - 4 + 12*Log[2]),
     {rh, 0, 10^(-4), 0.01, 1, 10, 100, 10^3}];
(*--#] *)
(*--#[ VNA*0*ex*term*6*and*9 *)
(* p .68 *)

VNA0ex3loopB[e_] := 29/12 + 9/(16*ep^2) - (43*Pi^2)/64 -
    (9/2)*L[(as*m)/muP]^2 - (5/8)*L[(m*muUS)/muP^2] -
    (3/8)*L[(m*muUS)/muP^2]^2 + 2*L[(as*m)/muP]*
     (-(1/4) + (3/2)*L[(m*muUS)/muP^2]) +
    (19/16 - (3/8)*L[(m*muUS)/muP^2] - (9*Log[2])/8)/ep - (35*Log[2])/8 +
    (3/4)*L[(m*muUS)/muP^2]*Log[2] + (9*Log[2]^2)/8 +
    (-(1/4) - (9/2)*L[(as*m)/muP] + (3/2)*L[(m*muUS)/muP^2])*Log[-e] -
    (9/8)*Log[-e]^2;

AAandBB[VNA0ex, term6and9][e_] :=
  Module[{}, expr1 = Expand[CA*CF*(Re[VNA0ex3loopB[e]]*"Im[Ghat(0,e)]" +
         Im[VNA0ex3loopB[e]]*ReGhat[e]) //. ComplexSimplify];
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2] +
      (1/ep)*Coefficient[expr1, ep, -1] + (Coefficient[expr1, ep, 0] /.
       "Im[Ghat(0,e)]" -> ImGhat[e])]

AAandBBsp[VNA0ex, term6and9][n_] :=
  Module[{}, expr1 = CA*CF*(VNA0ex3loopB[e] /. e -> -CF^2/(4*n^2));
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2]*"[Ghat(0,Eh)]" +
       (1/ep)*Coefficient[expr1, ep, -1]*"[Ghat(0,Eh)]" +
       Simplify[CF*Coefficient[expr1, ep, 0]] //. Log2s; expr = (2/3)*expr2]
(*--#] *)
(*--#[ VNA*0*ex*term*7 *)
(* p .70 *)

AA[VNA0ex, term7][e_] := Im[-12*Sqrt[-e]*(-1 + Log[2])];
BB[VNA0ex, term7][e_] := Im[Sqrt[-e]*(23.4193 - 7.36445*Log[-e])];
(*--#] *)
(*--#[ VNA*0*ex*term*8 *)
(* p .70 *)

AAandBB[VNA0ex, term8][e_] :=
   Expand[CA*CF*(Im[y]*6*(-1 + Log[2])*L[m*(as/muP)] +
       Im[y*(6*(-1 + Log[2])*Log[y] - (-4 - 2*Log[2] + 3*Log[2]^2))]) /.
     y -> Sqrt[-e]];
(*--#] *)
(*--#[ VV*1*ex*term*1 *)

AA[VV1ex, term1][e_, qmax_] :=
  Module[{}, A1termIntEx[ee_, q1_, q2_] :=
     Im[p*pp*AV0y[p, y]*(AVy[pp, y, g0] + SubAV1[pp, y])*E11[p, pp, ee] /.
       {y -> Sqrt[-ee], p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
    Off[NIntegrate::slwcon]; Off[NIntegrate::ncvb];
    expr = Chop[NIntegrate[(1/2)*q1*A1termIntEx[e, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
    On[NIntegrate::slwcon]; On[NIntegrate::ncvb]; expr]
BB[VV1ex, term1][e_, qmax_] :=
  Module[{}, B1termIntEx[ee_, q1_, q2_] :=
     Im[p*pp*AV0y[p, y]*(AVy[pp, y, g0] + SubAV1[pp, y])*E1log[p, pp, ee] /.
       {y -> Sqrt[-ee], p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
    Off[NIntegrate::slwcon]; Off[NIntegrate::ncvb];
    expr = Chop[NIntegrate[(1/2)*q1*B1termIntEx[e, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
    On[NIntegrate::slwcon]; On[NIntegrate::ncvb]; expr]

AAsp[VV1ex, term1][n_, qmax_] :=
  Module[{}, AtermInt[nn_, q1_, q2_] :=
     p1*p2*AV0y[p1, CF/(2*nn)]*ResidAVsub[p2, nn]*
       E11[p1, p2, -CF^2/(4*nn^2)] /. {p1 -> (q1 + q2)/2, p2 -> (q1 - q2)/2};
    Off[NIntegrate::slwcon]; Off[NIntegrate::ncvb];
    expr = Chop[NIntegrate[(1/2)*q1*AtermInt[n, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
    On[NIntegrate::slwcon]; On[NIntegrate::ncvb]; (2/3)*expr]
BBsp[VV1ex, term1][n_, qmax_] :=
  Module[{}, BtermInt[nn_, q1_, q2_] :=
     p1*p2*AV0y[p1, CF/(2*nn)]*ResidAVsub[p2, nn]*E1log[p1, p2,
        -CF^2/(4*nn^2)] /. {p1 -> (q1 + q2)/2, p2 -> (q1 - q2)/2};
    Off[NIntegrate::slwcon]; Off[NIntegrate::ncvb];
    expr = Chop[NIntegrate[(1/2)*q1*BtermInt[n, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)}]];
    On[NIntegrate::slwcon]; On[NIntegrate::ncvb]; (2/3)*expr]
(*--#] *)
(*--#[ VV*1*ex*term*2 *)

VV1ex3loop[e_] := 44/9 - 1/(8*ep^2) + (43*Pi^2)/96 + 2*L[(as*m)/muP]^2 +
    (41/12)*L[(m*muUS)/muP^2] + (1/4)*L[(m*muUS)/muP^2]^2 +
    (5/24 + (1/4)*L[(m*muUS)/muP^2] - (5*Log[2])/4)/ep - (245*Log[2])/12 -
    (13/2)*L[(m*muUS)/muP^2]*Log[2] + (65*Log[2]^2)/4 +
    2*L[(as*m)/muP]*(-(23/6) - L[(m*muUS)/muP^2] + 9*Log[2]) +
    (-(23/6) + 2*L[(as*m)/muP] - L[(m*muUS)/muP^2] + 9*Log[2])*Log[-e] +
    (1/2)*Log[-e]^2;

AAandBB[VV1ex, term2][e_] := Module[{},
   expr1 = Expand[CF*(CF - CA/2)*(Re[VV1ex3loop[e]]*"Im[Ghat(0,e)]" +
         Im[VV1ex3loop[e]]*ReGhat[e]) //. ComplexSimplify];
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2] +
      (1/ep)*Coefficient[expr1, ep, -1] + (Coefficient[expr1, ep, 0] /.
       "Im[Ghat(0,e)]" -> ImGhat[e])]

AAandBBsp[VV1ex, term2][n_] :=
  Module[{}, expr1 = CF*(CF - CA/2)*(VV1ex3loop[e] /. e -> -CF^2/(4*n^2));
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2]*"[Ghat(0,Eh)]" +
       (1/ep)*Coefficient[expr1, ep, -1]*"[Ghat(0,Eh)]" +
       Simplify[CF*Coefficient[expr1, ep, 0]] //. Log2s; expr = (2/3)*expr2]
(*--#] *)
(*--#[ VV*1*ex*term*3 *)

AA[VV1ex, term3][e_, qmax_] :=
  Module[{}, AtermInt[ee_, q1_, q2_] :=
     Im[p*pp*AV1[p, e]*AV[pp, e, g0]*E11[p, pp, e] /.
       {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}]; Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[(1/2)*q1*AtermInt[e, q1, x*q1],
       {q1, 10^(-6), 10^(-4), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, qmax},
       {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 1}]]; On[NIntegrate::slwcon];
    expr]

BB[VV1ex, term3][e_, qmax_] :=
  Module[{}, BtermInt[ee_, q1_, q2_] :=
     Im[p*pp*AV1[p, e]*AV[pp, e, g0]*E1log[p, pp, e] /.
       {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}]; Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[(1/2)*q1*BtermInt[e, q1, x*q1],
       {q1, 10^(-6), 10^(-4), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, qmax},
       {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 1}]]; On[NIntegrate::slwcon];
    expr]

AAsp[VV1ex, term3][npole_, qmax_] := AAsp[IIA, term5b][npole, qmax]
BBsp[VV1ex, term3][npole_, qmax_] := BBsp[IIA, term5b][npole, qmax]
(*--#] *)
(*--#[ VV*1*ex*term*4 *)
(* yk editted the line break of VV1ex00[e_]
 to make structure clearer *)
(* p .86 *)

VV1ex00[e_] := -(77/18) + 1/(4*ep^2) - (31*Pi^2)/48 - 4*L[(as*m)/muP\[CapitalGamma]]^2 -
    (23/6)*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2] - (1/2)*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2]^2 +
    2*L[(as*m)/muP\[CapitalGamma]]*(11/3 + 2*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2] - 10*Log[2]) +
    (113*Log[2])/6 + 7*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2]*Log[2] - (33*Log[2]^2)/2 +
    (1/12 - (1/2)*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2] + (3*Log[2])/2)/ep +
    (11/3 - 4*L[(as*m)/muP\[CapitalGamma]] + 2*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2] - 10*Log[2])*
     Log[-e] - Log[-e]^2;

AAandBB[VV1ex, term4][e_] := Module[{},
   expr1 = Expand[-((CF - CA/2)*(Re[VV1ex00[e]]*"\[CapitalGamma]t" +
          Im[VV1ex00[e]]*Re[e])) //. ComplexSimplify];
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2] +
      (1/ep)*Coefficient[expr1, ep, -1] + (Coefficient[expr1, ep, 0] /.
       "\[CapitalGamma]t" -> Im[e])]
(*--#] *)
(*--#[ VV*0*ex*term*1 *)
(* p .89 *)

IntVV0As[p_, y_] := (64*(-1 + 2*Log[1/p]))/(27*p) +
    (128*(Pi^2 + 3*y - 6*y*Log[1/p]))/(81*p^2*Pi) -
    (1/(2187*p^3))*(64*(-88 + 48*EulerGamma + 144*y - 72*y^2 +
       54*EulerGamma*y^2 - 81*y^2*Log[4] + 24*(2 + 9*y^2)*Log[1/p] -
       162*y^2*Log[y] + 48*Log[2*y] + 216*y^2*Log[2*y] +
       6*(8 + 9*y^2)*PolyGamma[0, 1 - 2/(3*y)])) +
    (1/(2187*p^4*Pi))*(128*(-4*Pi^2 - 88*y + 48*EulerGamma*y + 36*y^2 -
       45*Pi^2*y^2 - 99*y^3 + 54*EulerGamma*y^3 + 6*y*(8 + 45*y^2)*Log[1/p] +
       48*y*Log[2*y] + 54*y^3*Log[2*y] + 6*y*(8 + 9*y^2)*
        PolyGamma[0, 1 - 2/(3*y)])) + (1/(492075*p^5))*
     (32*(-4384 + 1920*EulerGamma + 8640*y - 71640*y^2 +
       43200*EulerGamma*y^2 + 129600*y^3 - 24381*y^4 + 38880*EulerGamma*y^4 +
       60*(32 + 720*y^2 + 1863*y^4)*Log[1/p] + 1920*Log[2*y] +
       43200*y^2*Log[2*y] + 38880*y^4*Log[2*y] + 480*(4 + 90*y^2 + 81*y^4)*
        PolyGamma[0, 1 - 2/(3*y)]));
IntVV0Ex[p_, y_] := p^2*AV1y[p, y]*(AVy[p, y, g1] + SubAV11[p, y])*
    E01[p, -y^2];
IntVV0[p_, y_] := If[Re[p] < 10^4, IntVV0Ex[p, y], IntVV0As[p, y]]

AA[VV0ex, term1][e_, pmax_] := Re[NIntegrate[Im[IntVV0[p, Sqrt[-e]]],
     {p, 0, 1, 10, 100, 10^3, 10^4, 10^5, 10^7, pmax}]];
BB[VV0ex, term1][e_, pmax_] :=
   Re[NIntegrate[Im[IntVV0[p, Sqrt[-e]]*-2*Log[p^2 - e]],
     {p, 0, 1, 10, 100, 10^3, 10^4, 10^5, 10^7, pmax}]];

IntVV0ppEx[nn_, p_] := p^2*AV1y[p, CF/(2*nn)]*ResidAVsub[p, nn]*
    E01[p, -CF^2/(4*nn^2)];
IntVV0ppAs[nn_, p_] := (8192*(213 + 616*nn^2 + 112*nn^4 + 4*nn^6))/
     (6200145*nn^6*p^7) - (4096*(4 + 10*nn^2 + nn^4))/(32805*nn^4*p^5) +
    (512*(1 + 2*nn^2))/(729*nn^2*p^3) + (8192*(29 + 70*nn^2 + 6*nn^4))/
     (295245*nn^5*p^6*Pi) - (2048*(1 + 2*nn^2))/(2187*nn^3*p^4*Pi);
IntVV0pp[nn_, p_] := If[Re[p] < 10^4, IntVV0ppEx[nn, p], IntVV0ppAs[nn, p]]

AAsp[VV0ex, term1][np_, pmax_] :=
   (2/3)*Re[NIntegrate[IntVV0pp[np, p], {p, 0, 1, 10, 100, 10^3, 10^4, 10^5,
       10^7, pmax}]];
BBsp[VV0ex, term1][np_, pmax_] :=
  (2/3)*Re[NIntegrate[IntVV0pp[np, p]*-2*Log[p^2 + CF^2/(4*np^2)],
     {p, 0, 1, 10, 100, 10^3, 10^4, 10^5, 10^7, pmax}]]
(*--#] *)
(*--#[ VV*0*ex*term*2*and*8 *)
(* p .90 *)

VV0ex3loopA[e_] := -(11/18) + 1/(4*ep^2) - (19*Pi^2)/48 +
    (10/3)*L[(as*m)/muP] - 4*L[(as*m)/muP]^2 - (11/6)*L[(m*muUS)/muP^2] +
    4*L[(as*m)/muP]*L[(m*muUS)/muP^2] - (1/2)*L[(m*muUS)/muP^2]^2 +
    (1/12 - (1/2)*L[(m*muUS)/muP^2] + Log[2]/2)/ep + (31*Log[2])/6 -
    12*L[(as*m)/muP]*Log[2] + 5*L[(m*muUS)/muP^2]*Log[2] - (17*Log[2]^2)/2 +
    (5/3 - 4*L[(as*m)/muP] + 2*L[(m*muUS)/muP^2] - 6*Log[2])*Log[-e] -
    Log[-e]^2;

AAandBB[VV0ex, term2and8][e_] :=
  Module[{}, expr1 = Expand[CF^2*(Re[VV0ex3loopA[e]]*"Im[Ghat(0,e)]" +
         Im[VV0ex3loopA[e]]*ReGhat[e]) //. ComplexSimplify];
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2] +
      (1/ep)*Coefficient[expr1, ep, -1] + (Coefficient[expr1, ep, 0] /.
       "Im[Ghat(0,e)]" -> ImGhat[e])]

AAandBBsp[VV0ex, term2and8][n_] :=
  Module[{}, expr1 = CF^2*(VV0ex3loopA[e] /. e -> -CF^2/(4*n^2));
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2]*"[Ghat(0,Eh)]" +
       (1/ep)*Coefficient[expr1, ep, -1]*"[Ghat(0,Eh)]" +
       Simplify[CF*Coefficient[expr1, ep, 0]] //. Log2s; expr = (2/3)*expr2]
(*--#] *)
(*--#[ VV*0*ex*term*3 *)

H1xx[v_] := Sqrt[v] + (1 + v)*ArcCsc[Sqrt[1 + v]];
H2xx[v_] := 2*ArcCsc[Sqrt[1 + v]];
H3xx[v_] := -2*(4*Sqrt[v/(1 + v)]*HypergeometricPFQ[{1/2, 1/2, 1/2},
       {3/2, 3/2}, v/(1 + v)] - Pi*Log[4] - Beta[v/(1 + v), 1/2, 1/2]*
      Log[v/(1 + v)] + Beta[1/(1 + v), 1/2, 1/2]*Log[1 + v]);
H3xx[v_] := NIntegrate[(-2/Sqrt[x])*(Log[(1 - x) + v]/Sqrt[(1 - x) + v]),
   {x, 0, 1}]
f1ExVV03[v_] := H2xx[v]
f2ExVV03[y_, v_] := (4/v)*H1xx[v] + H3xx[v] - 2*Log[y^2/v]*H2xx[v]

AA[VV0ex, term3][e_, pmax_] :=
  Module[{}, A1IntEx[p_, ee_] := 2*(CF^2/Pi)*(y^2/(p^2 + y^2))*
       f1ExVV03[y^2/p^2]*(AAy[p, y] + SubAA[p, y]) /. y -> Sqrt[-ee];
    Re[NIntegrate[Im[A1IntEx[p, e]], {p, 0, 0.01, 1, 10, 100, 10^3, 10^4.8,
       10^5, pmax}]]]
BB[VV0ex, term3][e_, pmax_] :=
    Module[{},
	   B1IntEx[p_, ee_] := 2*(CF^2/Pi)*(y^2/(p^2 + y^2))*
	       (f2ExVV03[y, y^2/p^2] - 4*Log[2]*f1ExVV03[y^2/p^2])*
		   (AAy[p, y] + SubAA[p, y]) /. y -> Sqrt[-ee];
	   Off[NIntegrate::inumr];
	   expr = Re[NIntegrate[Im[B1IntEx[p, e]], {p, 0, 0.01, 1, 2, 5, 10, 100,
						    10^3, 10^4.8, 10^5, pmax}]];
	   On[NIntegrate::inumr];
	   expr]

AAsp[VV0ex, term3][np_] := (2/3)*(1/2)*CF^3*(1/np^2 - 4*Log[2]);
BBsp[VV0ex, term3][np_, pmax_] :=
  Module[{}, BtermInt[nn_, pp_] := 2*(CF^2/Pi)*(CF^2/(4*nn^2))*
      (1/(pp^2 + CF^2/(4*nn^2)))*(f2ExVV03[CF/(2*nn), CF^2/(4*nn^2)/pp^2] -
       4*Log[2]*f1ExVV03[CF^2/(4*nn^2)/pp^2])*ResidAAsub[pp, nn];
    Off[NIntegrate::inum]; expr = Re[NIntegrate[BtermInt[np, p],
       {p, 0, 1, 10, 100, 10^3, 10^4, 10^5, 10^6, pmax}]];
    On[NIntegrate::inum]; (2/3)*expr]
(*--#] *)
(*--#[ VV*0*ex*term*4 *)
(* p .95 *)

VV0ex3loopB[e_] := 47/6 + 1/(2*ep) - Pi^2/3 - 4*L[(as*m)/muP] +
    L[(m*muUS)/muP^2] + (7*Log[2])/3 - 8*L[(as*m)/muP]*Log[2] +
    4*L[(m*muUS)/muP^2]*Log[2] - 8*Log[2]^2 + (-2 - 4*Log[2])*Log[-e];

AAandBB[VV0ex, term4][e_] := Module[{},
   expr1 = Expand[CF^2*(Re[VV0ex3loopB[e]]*"Im[Ghat(0,e)]" +
         Im[VV0ex3loopB[e]]*ReGhat[e]) //. ComplexSimplify];
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2] +
      (1/ep)*Coefficient[expr1, ep, -1] + (Coefficient[expr1, ep, 0] /.
       "Im[Ghat(0,e)]" -> ImGhat[e])]

AAandBBsp[VV0ex, term4][n_] :=
  Module[{}, expr1 = CF^2*(VV0ex3loopB[e] /. e -> -CF^2/(4*n^2));
    expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //. Log2s;
    expr2 = (1/ep^2)*Coefficient[expr1, ep, -2]*"[Ghat(0,Eh)]" +
       (1/ep)*Coefficient[expr1, ep, -1]*"[Ghat(0,Eh)]" +
       Simplify[CF*Coefficient[expr1, ep, 0]] //. Log2s; expr = (2/3)*expr2]
(*--#] *)
(*--#[ VV*0*ex*term*5 *)
(* p .96 *)

VV0ex00[e_] := -(61/18) - 1/(4*ep^2) + (19*Pi^2)/48 -
    (10/3)*L[(as*m)/muP\[CapitalGamma]] + 4*L[(as*m)/muP\[CapitalGamma]]^2 +
    (11/6)*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2] - 4*L[(as*m)/muP\[CapitalGamma]]*
     L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2] + (1/2)*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2]^2 +
    (-(1/12) + (1/2)*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2] - Log[2]/2)/ep - (31*Log[2])/6 +
    12*L[(as*m)/muP\[CapitalGamma]]*Log[2] - 5*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2]*Log[2] +
    (17*Log[2]^2)/2 + (-(5/3) + 4*L[(as*m)/muP\[CapitalGamma]] -
      2*L[(m*muUS\[CapitalGamma])/muP\[CapitalGamma]^2] + 6*Log[2])*Log[-e] + Log[-e]^2;

AAandBB[VV0ex, term5][e_] := Module[{},
   expr1 = Expand[-(CF*(Re[VV0ex00[e]]*"\[CapitalGamma]t" +
Im[VV0ex00[e]]*Re[e])) //.
       ComplexSimplify]; expr1 = Simplify[Series[expr1, {ep, 0, 0}]] //.
      Log2s; expr2 = (1/ep^2)*Coefficient[expr1, ep, -2] +
      (1/ep)*Coefficient[expr1, ep, -1] + (Coefficient[expr1, ep, 0] /.
       "\[CapitalGamma]t" -> Im[e])]
(*--#] *)
(*--#[ VV*0*ex*term*6 *)
(* p .96 *)

AAandBB[VV0ex, term6][e_] :=
Im[2*(-e)^(3/2)]*2*L[(as^2*m)/muUS\[CapitalGamma]] +
    Im[2*(-e)^(3/2)*(-7 + 6*Log[2] + 2*Log[-e])];
(*--#] *)
(*--#[ VV*0*ex*term*7 *)
(* p .91 *)

IntVV07As[p_, y_] := -((16*Pi)/9) + (16*(4 + Pi^2)*y^2)/(9*p^2*Pi) -
    (64*y^3)/(27*p^3) - (16*(4 + Pi^2)*y^4)/(9*p^4*Pi) +
    (512*y^5)/(135*p^5) + (16*(32 + 9*Pi^2)*y^6)/(81*p^6*Pi) -
    (4544*y^7)/(945*p^7);
IntVV07Ex[p_, y_] := p^2*AV1y[p, y]*(AV1y[p, y] + SubAV10[p, y])*
    E01[p, -y^2];
IntVV07[p_, y_] := If[Re[p] < 10^4, IntVV07Ex[p, y], IntVV07As[p, y]]

AA[VV0ex, term7][e_] := CF^2*(4 + Pi^2/6)*Im[Sqrt[-e]];

BB[VV0ex, term7][e_, pmax_] :=
  Re[NIntegrate[Im[IntVV07[p, Sqrt[-e]]*-2*Log[p^2 - e]],
    {p, 0, 1, 10, 100, 10^3, 10^4, 10^5, 10^7, pmax}]]
(*--#] *)

(*--#[ US*Sum*of*all *)
(*
Final result for Green function in units of 8/3 gs^2 CF m^2 as^3/(4 Pi)^3. \
e=E/m as^2
For energy level and |psi (0)|^2 the correction relative to the leading order \
expression is given in units of as^3/Pi
L[x] = ln (x)

Notes:
 a) By definition (notes p .34) the IIA terms do not contain the 1/ep pole
 b) The [1/(4 ep)-Log[m as/mu]] terms from the overall divergence are left \
out, because we already demonstrated their
      cancellation.
 c) In the expression for Psi0, one should replace  "[Ghat(0,Eh)]" by CF=4/3, \
because Ghat (0,Eh)->CF/(n-\[Lambda]) near the
      bound state pole. Then formally the leading order expression for \
|psi (0)|^2 is understood as d-dimensional

 Terms that take long:
 IIA terms
*)

GreenF[e_] :=
    tt[typeI, all]*Identity[BB[typeI, all][e]] +
    tt[IIA, ex0]*Identity[(AA[IIA, ex0][e, 10^9]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		  BB[IIA, ex0][e, 10^9])] +
    tt[IIA, ex1]*Identity[(AA[IIA, ex1][e, 10^9]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		  BB[IIA, ex1][e, 10^9])] +
    tt[IIA, term5b]*Identity[(AA[IIA, term5b][e, 10^7]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		     BB[IIA, term5b][e, 10^7])] +
    tt[NANA, term1]*Identity[2*(AA[NANA, term1][e, Infinity]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		       BB[NANA, term1][e, Infinity])] +
    tt[NANA, term2]*Identity[2*(AA[NANA, term2][e]*(-2*L[m*(as/muP)]) + BB[NANA, term2][e])] +
    tt[NANA, term3and6]*Identity[2*AAandBB[NANA, term3and6][e]] +
    tt[NANA, term4]*Identity[(AA[NANA, term4][e]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		     BB[NANA, term4][e])] +
    tt[NANA, term5]*Identity[AAandBB[NANA, term5][e]] +
(*
    tt[VNA1ex, term1]*Identity[2*(AA[VNA1ex, term1][e, 10^7]*
			 (-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) + BB[VNA1ex, term1][e, 10^7])] +
*)
    tt[VNA1ex, term1]*Identity[2*(AAandBB[VNA1ex, term1][e, 10^7](* +
				AA[VNA1ex, term1][e, 10^7]*(-2*L[m*(as^2/muUS)])*))] +

    tt[VNA1ex, term2]*Identity[2*(AA[VNA1ex, term2][e]*(-2*L[m*(as/muP)]) +
			 BB[VNA1ex, term2][e])] +
    tt[VNA1ex, term3and6]*Identity[2*AAandBB[VNA1ex, term3and6][e]] +
    tt[VNA1ex, term4]*Identity[(AA[VNA1ex, term4][e, 10^7]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		       BB[VNA1ex, term4][e, 10^7])] +
    tt[VNA1ex, term5]*Identity[AAandBB[VNA1ex, term5][e]] +
    tt[VNA0ex, term1]*Identity[2*BB[VNA0ex, term1][e]] +
    tt[VNA0ex, term2]*Identity[2*BB[VNA0ex, term2][e]] +
    tt[VNA0ex, term3]*Identity[AAandBB[VNA0ex, term3][e]] +
    tt[VNA0ex, term4]*Identity[2*(AA[VNA0ex, term4][e, Infinity]*
			 (-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) + BB[VNA0ex, term4][e, Infinity])] +
    tt[VNA0ex, term5]*Identity[2*(AA[VNA0ex, term5][e]*(-2*L[m*(as/muP)]) +
			 BB[VNA0ex, term5][e])] +
    tt[VNA0ex, term6and9]*Identity[2*AAandBB[VNA0ex, term6and9][e]] +
    tt[VNA0ex, term7]*Identity[(AA[VNA0ex, term7][e]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		       BB[VNA0ex, term7][e])] +
    tt[VNA0ex, term8]*Identity[AAandBB[VNA0ex, term8][e]] +
    tt[VV1ex, term1]*Identity[2*(AA[VV1ex, term1][e, 10^7]*
			(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) + BB[VV1ex, term1][e, 10^7])] +
    tt[VV1ex, term2]*Identity[2*AAandBB[VV1ex, term2][e]] +
    tt[VV1ex, term3]*Identity[(AA[VV1ex, term3][e, 10^7]*
		      (-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) + BB[VV1ex, term3][e, 10^7])] +
    tt[VV1ex, term4]*Identity[AAandBB[VV1ex, term4][e]] +
    tt[VV0ex, term1]*Identity[2*(AA[VV0ex, term1][e, 10^8]*
			(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) + BB[VV0ex, term1][e, 10^8])] +
    tt[VV0ex, term2and8]*Identity[2*AAandBB[VV0ex, term2and8][e]] +
    tt[VV0ex, term3]*Identity[2*(AA[VV0ex, term3][e, 10^5]*
			(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) + BB[VV0ex, term3][e, 10^5])] +
    tt[VV0ex, term4]*Identity[2*AAandBB[VV0ex, term4][e]] +
    tt[VV0ex, term5]*Identity[2*AAandBB[VV0ex, term5][e]] +
    tt[VV0ex, term6]*Identity[AAandBB[VV0ex, term6][e]] +
    tt[VV0ex, term7]*Identity[(AA[VV0ex, term7][e]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		      BB[VV0ex, term7][e, 10^8])] +
    tt[match, term1]*Identity[(AA[match, term1][e]*(2*L[m*(as/muP)]) + BB[match, term1][e])] +
    tt[match, term2]*Identity[AAandBB[match, term2][e]]
Energy[np_] :=
    tt[typeI, all]*BBdp[typeI, all][np] +
    tt[IIA, ex0]*(AAdp[IIA, ex0][np]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		  BBdp[IIA, ex0][np]) +
    tt[IIA, ex1]*(AAdp[IIA, ex1][np]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		  BBdp[IIA, ex1][np]) +
    tt[match, term1]*(AAdp[match, term1][np]*(2*L[m*(as/muP)]) + BBdp[match, term1][np]) +
    tt[match, term2]*AAandBBdp[match, term2][np]
Psi0[np_] :=
    tt[typeI, all]*BBsp[typeI, all][np] +
    tt[IIA, ex0]*(AAsp[IIA, ex0][np]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		  BBsp[IIA, ex0][np]) +
    tt[IIA, ex1]*(AAsp[IIA, ex1][np]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		  BBsp[IIA, ex1][np]) +
    tt[IIA, term5b]*(AAsp[IIA, term5b][np, 10^8]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		     BBsp[IIA, term5b][np, 10^8]) +
    2*tt[NANA, term1]*(AAsp[NANA, term1][np]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		       BBsp[NANA, term1][np]) +
    2*tt[NANA, term2]*(AAsp[NANA, term2][np]*(-2*L[m*(as/muP)]) + BBsp[NANA, term2][np]) +
    2*tt[NANA, term3and6]*AAandBBsp[NANA, term3and6][np] +
    2*tt[VNA1ex, term1]*(AAsp[VNA1ex, term1][np, 10^7]*
			 (-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) + BBsp[VNA1ex, term1][np, 10^7]) +
    2*tt[VNA1ex, term2]*(AAsp[VNA1ex, term2][np]*(-2*L[m*(as/muP)]) +
			 BBsp[VNA1ex, term2][np]) +
    2*tt[VNA1ex, term3and6]*AAandBBsp[VNA1ex, term3and6][np] +
    2*tt[VNA0ex, term1]*BBsp[VNA0ex, term1][np] +
    2*tt[VNA0ex, term2]*BBsp[VNA0ex, term2][np] +
    2*tt[VNA0ex, term4]*(AAsp[VNA0ex, term4][np]*
			 (-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) + BBsp[VNA0ex, term4][np]) +
    2*tt[VNA0ex, term5]*(AAsp[VNA0ex, term5][np]*(-2*L[m*(as/muP)]) +
			 BBsp[VNA0ex, term5][np]) +
    2*tt[VNA0ex, term6and9]*AAandBBsp[VNA0ex, term6and9][np] +
    2*tt[VV1ex, term1]*(AAsp[VV1ex, term1][np, 10^7]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
			BBsp[VV1ex, term1][np, 10^7]) +
    2*tt[VV1ex, term2]*AAandBBsp[VV1ex, term2][np] +
    tt[VV1ex, term3]*(AAsp[VV1ex, term3][np, 10^8]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
		      BBsp[VV1ex, term3][np, 10^8]) +
    2*tt[VV0ex, term1]*(AAsp[VV0ex, term1][np, 10^8]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
			BBsp[VV0ex, term1][np, 10^8]) +
    2*tt[VV0ex, term2and8]*AAandBBsp[VV0ex, term2and8][np] +
    2*tt[VV0ex, term3]*(AAsp[VV0ex, term3][np]*(-2*L[2*Exp[-5/6]*m*(as^2/muUS)]) +
			BBsp[VV0ex, term3][np, 10^6]) +
    2*tt[VV0ex, term4]*AAandBBsp[VV0ex, term4][np] +
    tt[match, term1]*(AAsp[match, term1][np]*(2*L[m*(as/muP)]) + BBsp[match, term1][np]) +
    tt[match, term2]*AAandBBsp[match, term2][np]
(*--#] *)

(* US*Improvement *)

(*--#[ type1*Functions *)

I0[a_, n_] := ((Gamma[1 + a]*Gamma[4 + n])/(n!*Gamma[4]))*
    (2/(1 + \[Nu]))^(1 + a)*Hypergeometric2F1[-n, a + 1, 4, 2/(1 + \[Nu])];
J1[a_, n_] := Sum[(-1)^k*(Binomial[n + 3, n - k]/k!)*
     (Gamma[a + k + 1]/(a + k + 1))*(2/(1 + \[Nu]))^(a + k + 1)*
     Hypergeometric2F1[a + k + 1, 1, a + k + 2, (1 - \[Nu])/(1 + \[Nu])],
    {k, 0, n}];
IL1L3[a_, n_, m_] := Sum[(((-1)^k*(n + 1)!*(3 + m)!*(a + k)!)/
      ((n - k)!*(k + 1)!*k!*3!*m!))*(2/(1 + \[Nu]))^(1 + a + k)*\[Nu]^k*
     Hypergeometric2F1[-m, a + k + 1, 4, 2/(1 + \[Nu])], {k, 0, n}];
Do[H0[n, \[Lambda]_, \[Nu]_] = (1/(\[Nu]*\[Lambda]))*(((1 - \[Nu]^2)/4)*I0[3, n] -
       ((2 + n) - rAF*\[Lambda]*\[Nu])*I0[2, n]);
H1[n, \[Lambda]_, \[Nu]_] = Simplify[FunctionExpand[
       (1/\[Nu])*((((1 - \[Nu]^2)/4)*D[I0[3 + \[Epsilon], n], {\[Epsilon], 1}] -
           ((2 + n) - rAF*\[Lambda]*\[Nu])*D[I0[2 + \[Epsilon], n], {\[Epsilon], 1}]) +
          Log[\[Nu]*E^EulerGamma]*(((1 - \[Nu]^2)/4)*I0[3, n] -
            ((2 + n) - rAF*\[Lambda]*\[Nu])*I0[2, n]) + (((1 - \[Nu]^2)/4)*J1[3, n] -
           ((2 + n) - rAF*\[Lambda]*\[Nu])*J1[2, n])) /. \[Epsilon] -> 0]];
    Hn[n, \[Lambda]_, \[Nu]_] = Sum[(1/\[Lambda])*((\[Lambda]/(m + 1))^2/(m + 1 - \[Lambda]))*
       (((1 - \[Nu]^2)/4)*IL1L3[4, m, n] - ((2 + n) - rAF*\[Lambda]*\[Nu])*
         IL1L3[3, m, n]), {m, 0, 10}]; , {n, 0, 20}];

Do[H0[n, \[Lambda]_, \[Nu]_, {ApproxAt0}] =
     Simplify[Normal[Series[H0[n, \[Lambda], \[Nu]], {\[Nu], 0, 10}]]];
    H1[n, \[Lambda]_, \[Nu]_, {ApproxAt0}] =
     Simplify[Normal[Series[H1[n, \[Lambda], \[Nu]], {\[Nu], 0, 10}]]];
    H1[n, \[Lambda]_, \[Nu]_, {ApproxAt1}] =
     Simplify[Normal[Series[H1[n, \[Lambda], \[Nu]], {\[Nu], 1, 10}]]];
    Hn[n, \[Lambda]_, \[Nu]_, {ApproxAt0}] =
     Simplify[Normal[Series[Hn[n, \[Lambda], \[Nu]], {\[Nu], 0, 10}]]]; , {n, 0, 20}];

H0[n_, \[Lambda]_, \[Nu]_, {approx}] := If[Abs[\[Nu]] < 10^(-2),
    H1[n, \[Lambda], \[Nu], {ApproxAt0}], H0[n, \[Lambda], \[Nu]]];
H1[n_, \[Lambda]_, \[Nu]_, {approx}] := Which[Abs[\[Nu]] < 10^(-2),
    H1[n, \[Lambda], \[Nu], {ApproxAt0}], Abs[\[Nu] - 1] < 10^(-1),
    H1[n, \[Lambda], \[Nu], {ApproxAt1}], True, H1[n, \[Lambda], \[Nu]]];
Hn[n_, \[Lambda]_, \[Nu]_, {approx}] := If[Abs[\[Nu]] < 10^(-2),
    Hn[n, \[Lambda], \[Nu], {ApproxAt0}], Hn[n, \[Lambda], \[Nu]]];

(* NGF[e, {type1, degits}] *)

NGF[energy_, {type1, delN_}] := Module[{StandardNorm, NormFac, VV01NorFac},
    StandardNorm = mt^2*cF*(al^4/(6*Pi^2));
     NormFac = Simplify[StandardNorm/norm]; cF := 4/3; cA := 3;
     rAF := 1 - cA/(2*cF); NGValue[{type1x00}, et_] :=
      Chop[NIntegrate[Im[(cF^3/8)*(((-\[Nu]^3)*\[Lambda])/(2*et))*
            Sum[(Gamma[1 + n8]/Gamma[4 + n8])*(rAF/(n8 + 2))^2*(1 - \[Nu]^2)*
              (H0[n8, \[Lambda], \[Nu]]^2/(n8 + 2 - rAF*\[Lambda]*\[Nu])), {n8, 0, 10}] /.
           \[Lambda] -> cF/(2*Sqrt[-et]) /. \[Nu] -> Sqrt[-et/(kt - et)]],
        {kt, 0, 1, 10^2, 10^3, 10^4, 10^5, 10^6, 10^7, 10^8, 10^9},
        PrecisionGoal -> delN]]; NGValue[{type1x01}, et_] :=
      Chop[NIntegrate[Im[(cF^3/8)*(((-\[Nu]^3)*\[Lambda])/(2*et))*
            Sum[(Gamma[1 + n8]/Gamma[4 + n8])*(rAF/(n8 + 2))^2*(1 - \[Nu]^2)*
              ((H0[n8, \[Lambda], \[Nu]]*H1[n8, \[Lambda], \[Nu], {approx}])/(n8 + 2 -
                rAF*\[Lambda]*\[Nu])), {n8, 0, 10}] /. \[Lambda] -> cF/(2*Sqrt[-et]) /.
          \[Nu] -> Sqrt[-et/(kt - et)]], {kt, 0, 1, 10^1, 10^2, 10^3, 10^4,
         10^5, 10^6, 10^7, 10^8, 10^9}, PrecisionGoal -> delN]];
     NGValue[{type1x0n}, et_] :=
      Chop[NIntegrate[Im[(cF^3/8)*(((-\[Nu]^3)*\[Lambda])/(2*et))*
            Sum[(Gamma[1 + n8]/Gamma[4 + n8])*(rAF/(n8 + 2))^2*(1 - \[Nu]^2)*
              ((H0[n8, \[Lambda], \[Nu]]*Hn[n8, \[Lambda], \[Nu], {approx}])/(n8 + 2 -
                rAF*\[Lambda]*\[Nu])), {n8, 0, 10}] /. \[Lambda] -> cF/(2*Sqrt[-et]) /.
          \[Nu] -> Sqrt[-et/(kt - et)]], {kt, 0, 1, 10^1, 10^2, 10^3, 10^4,
         10^5, 10^6, 10^7, 10^8, 10^9}, PrecisionGoal -> delN]];
     NGValue[{type1x11}, et_] :=
      Chop[NIntegrate[Im[(cF^3/8)*(((-\[Nu]^3)*\[Lambda])/(2*et))*
            Sum[(Gamma[1 + n8]/Gamma[4 + n8])*(rAF/(n8 + 2))^2*(1 - \[Nu]^2)*
              ((H1[n8, \[Lambda], \[Nu], {approx}]*H1[n8, \[Lambda], \[Nu], {approx}])/(n8 +
                2 - rAF*\[Lambda]*\[Nu])), {n8, 0, 10}] /. \[Lambda] -> cF/(2*Sqrt[-et]) /.
          \[Nu] -> Sqrt[-et/(kt - et)]], {kt, 0, 1, 10^1, 10^2, 10^3, 10^4,
         10^5, 10^6, 10^7, 10^8, 10^9}, PrecisionGoal -> delN]];
     NGValue[{type1x1n}, et_] :=
      Chop[NIntegrate[Im[(cF^3/8)*(((-\[Nu]^3)*\[Lambda])/(2*et))*
            Sum[(Gamma[1 + n8]/Gamma[4 + n8])*(rAF/(n8 + 2))^2*(1 - \[Nu]^2)*
              ((H1[n8, \[Lambda], \[Nu], {approx}]*Hn[n8, \[Lambda], \[Nu], {approx}])/(n8 +
                2 - rAF*\[Lambda]*\[Nu])), {n8, 0, 10}] /. \[Lambda] -> cF/(2*Sqrt[-et]) /.
          \[Nu] -> Sqrt[-et/(kt - et)]], {kt, 0, 1, 10^1, 10^2, 10^3, 10^4,
         10^5, 10^6, 10^7, 10^8, 10^9}, PrecisionGoal -> delN]];
     NGValue[{type1xnn}, et_] :=
      Chop[NIntegrate[Im[(cF^3/8)*(((-\[Nu]^3)*\[Lambda])/(2*et))*
            Sum[(Gamma[1 + n8]/Gamma[4 + n8])*(rAF/(n8 + 2))^2*(1 - \[Nu]^2)*
              ((Hn[n8, \[Lambda], \[Nu]]*Hn[n8, \[Lambda], \[Nu]])/(n8 + 2 - rAF*\[Lambda]*\[Nu])),
             {n8, 0, 10}] /. \[Lambda] -> cF/(2*Sqrt[-et]) /.
          \[Nu] -> Sqrt[-et/(kt - et)]], {kt, 0, 1, 10^1, 10^2, 10^3, 10^4,
         10^5, 10^6, 10^7, 10^8, 10^9}, PrecisionGoal -> delN]];
     Block[{$Messages = {}}, {NGValue[{type1x00}, energy],
       2*NGValue[{type1x01}, energy], 2*NGValue[{type1x0n}, energy],
       NGValue[{type1x11}, energy], 2*NGValue[{type1x1n}, energy],
       NGValue[{type1xnn}, energy]}]];

BB[typeI, all][e_] := Plus @@ NGF[e, {type1, 5}]
(*--#] *)
(*--#[ IIA*1*ex*(NANA + VNA + VV*combined), ex*IIA*(NANA + VNA + combined*VV) *)

AA[IIA, ex1][e_, qmax_] := Module[{},
   int1[ee_, q1_, q2_] := Im[p*pp*(AV[p, ee, g1]*AV[pp, ee, g1] +
         AV[p, ee, g0]*ANA[pp, ee, g0] + AV[pp, ee, g0]*ANA[p, ee, g0] +
         ANA[p, ee, all]*ANA[pp, ee, all])*E11[p, pp, ee] /.
       {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
    intIO = Simplify[(q1*int1[e, q1, x*q1] /. q1 -> (q1 + 1)/(q1 - 1))*
       D[(q1 + 1)/(q1 - 1), q1]]; Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[intIO, {q1, -1, -0.001, -10^(-7), 10^(-6), 0.01,
        1 - 1/qmax}, {x, 10^(-7), 1}, PrecisionGoal -> 3]];
    On[NIntegrate::slwcon]; expr]
BB[IIA, ex1][e_, qmax_] := Module[
   {},
   intlog[ee_, q1_, q2_] := Im[
      p*pp*(
         AV[p, ee, g1]*AV[pp, ee, g1] +
         AV[p, ee, g0]*ANA[pp, ee, g0] +
         AV[pp, ee, g0]*ANA[p, ee, g0] +
         ANA[p, ee, all]*ANA[pp, ee, all]
      )*E1log[p, pp, ee] /.
      {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}
   ];
   Off[NIntegrate::slwcon];
   intIO = (q1*intlog[e, q1, x*q1] /. q1 -> (1 - q1)/q1)*D[(1 - q1)/q1, q1];
   expr = -Chop[
      NIntegrate[
         intIO,
         {q1, 1/qmax, 1 - 1/qmax},
         {x, 10^(-7), 1},
         PrecisionGoal -> 5
      ]
   ];
   On[NIntegrate::slwcon];
   expr
]

AAdp[IIA, ex1][npole_] := Module[{},
   f1ex[p_, pp_] := Simplify[Series[p*pp*(AVpole[p, npole, all] +
         ANApole[p, npole, all])*(AVpole[pp, npole, all] +
         ANApole[pp, npole, all])*E11[p, pp, -CF^2/(4*(npole - epl)^2)],
       {epl, 0, -2}]]; f1exdp[p_, pp] := Coefficient[f1ex[p, pp], epl, -2];
    int1dp[q1_, q2_] := f1exdp[p, pp] /. {p -> (q1 + q2)/2,
       pp -> (q1 - q2)/2}; dp = Chop[NIntegrate[q1*int1dp[q1, x*q1],
       {q1, 10^(-6), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, 10^7, 10^8},
       {x, 10^(-7), 1}, PrecisionGoal -> 3]]; Expand[(2/3)*(2/npole)*dp]]
BBdp[IIA, ex1][npole_] := Module[{},
   f1ex[p_, pp_] := Simplify[Series[p*pp*(AVpole[p, npole, all] +
         ANApole[p, npole, all])*(AVpole[pp, npole, all] +
         ANApole[pp, npole, all])*E1log[p, pp, -CF^2/(4*(npole - epl)^2)],
       {epl, 0, -2}]]; f1exdp[p_, pp] := Coefficient[f1ex[p, pp], epl, -2];
    int1dp[q1_, q2_] := f1exdp[p, pp] /. {p -> (q1 + q2)/2,
       pp -> (q1 - q2)/2}; dp = Chop[NIntegrate[q1*int1dp[q1, x*q1],
       {q1, 10^(-6), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, 10^7, 10^8},
       {x, 10^(-7), 1}, PrecisionGoal -> 3]]; Expand[(2/3)*(2/npole)*dp]]

AAsp[IIA, ex1][npole_] := Module[{},
   sub1[p_, pp_] := AVpole[p, npole, g1]*AVpole[pp, npole, g1] +
      AVpole[p, npole, g0]*ANApole[pp, npole, g0] + AVpole[pp, npole, g0]*
       ANApole[p, npole, g0] + ANApole[p, npole, all]*
       ANApole[pp, npole, all]; f1ex[p_, pp_] :=
     Simplify[Series[p*pp*sub1[p, pp]*E11[p, pp, -CF^2/(4*(npole - epl)^2)],
       {epl, 0, -1}]]; f1exdp[p_, pp_] = Coefficient[f1ex[p, pp], epl, -2];
    f1exsp[p_, pp_] = Simplify[Coefficient[f1ex[p, pp], epl, -1]];
    int1dp[q1_, q2_] := Re[f1exdp[p, pp]] /. {p -> (q1 + q2)/2,
       pp -> (q1 - q2)/2}; dp = Chop[NIntegrate[q1*int1dp[q1, x*q1],
       {q1, 10^(-5), 1, 10, 10^2, 10^3, 10^4, 10^5, 10^7}, {x, 10^(-7), 1},
       PrecisionGoal -> 3]]; int1sp[q1_, q2_] := Re[f1exsp[p, pp]] /.
      {p -> (q1 + q2)/2, pp -> (q1 - q2)/2};
    sp = Chop[NIntegrate[Chop[N[q1*int1sp[q1, x*q1]]],
       {q1, 10^(-5), 1, 10, 10^2, 10^3, 10^4, 10^5, 10^6, 10^7, 10^8},
       {x, 10^(-7), 1}, PrecisionGoal -> 3]];
    Expand[(2/3)*(sp + 3*(dp/npole))]]
BBsp[IIA, ex1][npole_] := Module[{},
   sub1[p_, pp_] := AVpole[p, npole, g1]*AVpole[pp, npole, g1] +
      AVpole[p, npole, g0]*ANApole[pp, npole, g0] + AVpole[pp, npole, g0]*
       ANApole[p, npole, g0] + ANApole[p, npole, all]*
       ANApole[pp, npole, all]; f1ex[p_, pp_] :=
     Simplify[Series[p*pp*sub1[p, pp]*E1log[p, pp,
         -CF^2/(4*(npole - epl)^2)], {epl, 0, -1}]];
    f1exdp[p_, pp_] = Coefficient[f1ex[p, pp], epl, -2];
    f1exsp[p_, pp_] = Simplify[Coefficient[f1ex[p, pp], epl, -1]];
    int1dp[q1_, q2_] := Re[f1exdp[p, pp]] /. {p -> (q1 + q2)/2,
       pp -> (q1 - q2)/2}; dp = Chop[NIntegrate[q1*int1dp[q1, x*q1],
       {q1, 10^(-5), 1, 10, 10^2, 10^3, 10^4, 10^5, 10^7}, {x, 10^(-7), 1},
       PrecisionGoal -> 3]]; int1sp[q1_, q2_] := Re[f1exsp[p, pp]] /.
      {p -> (q1 + q2)/2, pp -> (q1 - q2)/2};
    sp = Chop[NIntegrate[Chop[N[q1*int1sp[q1, x*q1]]],
       {q1, 10^(-5), 1, 10, 10^2, 10^3, 10^4, 10^5, 10^6, 10^7, 10^8},
       {x, 10^(-7), 1}, PrecisionGoal -> 3]];
    Expand[(2/3)*(sp + 3*(dp/npole))]]
(*--#] *)
(*--#[ IIA 1ex  (VV, term 5b) *)

AA[IIA, term5b][e_, qmax_] := Module[{},
   AtermInt[ee_, q1_, q2_] := Im[p*pp*AV1[p, ee]*AV[pp, ee, g1]*
        E11[p, pp, ee] /. {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
    Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[(1/2)*q1*AtermInt[e, q1, x*q1],
       {q1, 10^(-6), 10^(-4), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, qmax},
       {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 1}, PrecisionGoal -> 3]];
    On[NIntegrate::slwcon]; expr]
BB[IIA, term5b][e_, qmax_] := Module[{},
   BtermInt[ee_, q1_, q2_] := Im[p*pp*AV1[p, ee]*AV[pp, ee, g1]*
        E1log[p, pp, ee] /. {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
    Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[(1/2)*q1*BtermInt[e, q1, x*q1],
       {q1, 10^(-6), 10^(-4), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, qmax},
       {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 1}, PrecisionGoal -> 4]];
    On[NIntegrate::slwcon]; expr]

AAsp[IIA, term5b][npole_, qmax_] :=
  Module[{}, AtermInt[nn_, q1_, q2_] := p1*p2*AV1[p1, -CF^2/(4*nn^2)]*
       ResidAV[p2, nn]*E11[p1, p2, -CF^2/(4*nn^2)] /.
      {p1 -> (q1 + q2)/2, p2 -> (q1 - q2)/2};
    sp = Chop[NIntegrate[(1/2)*q1*AtermInt[npole, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)},
       PrecisionGoal -> 3]]; Expand[(2/3)*sp]]
BBsp[IIA, term5b][npole_, qmax_] :=
  Module[{}, BtermInt[nn_, q1_, q2_] := p1*p2*AV1[p1, -CF^2/(4*nn^2)]*
       ResidAV[p2, nn]*E1log[p1, p2, -CF^2/(4*nn^2)] /.
      {p1 -> (q1 + q2)/2, p2 -> (q1 - q2)/2};
    sp = Chop[NIntegrate[(1/2)*q1*BtermInt[npole, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)},
       PrecisionGoal -> 3]]; Expand[(2/3)*sp]]
(*--#] *)
(*--#[ VV*1*ex*term*1 *)

AA[VV1ex, term1][e_, qmax_] :=
  Module[{}, A1termIntEx[ee_, q1_, q2_] :=
     Im[p*pp*AV0y[p, y]*(AVy[pp, y, g0] + SubAV1[pp, y])*E11[p, pp, ee] /.
       {y -> Sqrt[-ee], p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
    Off[NIntegrate::slwcon]; Off[NIntegrate::ncvb];
    expr = Chop[NIntegrate[(1/2)*q1*A1termIntEx[e, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)},
       PrecisionGoal -> 3]]; On[NIntegrate::slwcon]; On[NIntegrate::ncvb];
    expr]
BB[VV1ex, term1][e_, qmax_] :=
  Module[{}, B1termIntEx[ee_, q1_, q2_] :=
     Im[p*pp*AV0y[p, y]*(AVy[pp, y, g0] + SubAV1[pp, y])*E1log[p, pp, ee] /.
       {y -> Sqrt[-ee], p -> (q1 + q2)/2, pp -> (q1 - q2)/2}];
    Off[NIntegrate::slwcon]; Off[NIntegrate::ncvb];
    expr = Chop[NIntegrate[(1/2)*q1*B1termIntEx[e, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)},
       PrecisionGoal -> 4]]; On[NIntegrate::slwcon]; On[NIntegrate::ncvb];
    expr]

AAsp[VV1ex, term1][n_, qmax_] :=
  Module[{}, AtermInt[nn_, q1_, q2_] :=
     p1*p2*AV0y[p1, CF/(2*nn)]*ResidAVsub[p2, nn]*
       E11[p1, p2, -CF^2/(4*nn^2)] /. {p1 -> (q1 + q2)/2, p2 -> (q1 - q2)/2};
    Off[NIntegrate::slwcon]; Off[NIntegrate::ncvb];
    expr = Chop[NIntegrate[(1/2)*q1*AtermInt[n, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)},
       PrecisionGoal -> 3]]; On[NIntegrate::slwcon]; On[NIntegrate::ncvb];
    (2/3)*expr]
BBsp[VV1ex, term1][n_, qmax_] :=
  Module[{}, BtermInt[nn_, q1_, q2_] :=
     p1*p2*AV0y[p1, CF/(2*nn)]*ResidAVsub[p2, nn]*E1log[p1, p2,
        -CF^2/(4*nn^2)] /. {p1 -> (q1 + q2)/2, p2 -> (q1 - q2)/2};
    Off[NIntegrate::slwcon]; Off[NIntegrate::ncvb];
    expr = Chop[NIntegrate[(1/2)*q1*BtermInt[n, q1, x*q1],
       {q1, 10^(-6), 10^(-5), 10^(-3), 0.01, 0.1, 10, 10^3, 10^4, 10^5,
        qmax}, {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 0.9, 1 - 10^(-6)},
       PrecisionGoal -> 3]]; On[NIntegrate::slwcon]; On[NIntegrate::ncvb];
    (2/3)*expr]
(*--#] *)
(*--#[ VV*1*ex*term*3 *)

AA[VV1ex, term3][e_, qmax_] :=
  Module[{}, AtermInt[ee_, q1_, q2_] :=
     Im[p*pp*AV1[p, e]*AV[pp, e, g0]*E11[p, pp, e] /.
       {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}]; Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[(1/2)*q1*AtermInt[e, q1, x*q1],
       {q1, 10^(-6), 10^(-4), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, qmax},
       {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 1}, PrecisionGoal -> 3]];
    On[NIntegrate::slwcon]; expr]
BB[VV1ex, term3][e_, qmax_] :=
  Module[{}, BtermInt[ee_, q1_, q2_] :=
     Im[p*pp*AV1[p, e]*AV[pp, e, g0]*E1log[p, pp, e] /.
       {p -> (q1 + q2)/2, pp -> (q1 - q2)/2}]; Off[NIntegrate::slwcon];
    expr = Chop[NIntegrate[(1/2)*q1*BtermInt[e, q1, x*q1],
       {q1, 10^(-6), 10^(-4), 0.01, 1, 10, 10^2, 10^3, 10^4, 10^5, qmax},
       {x, -1, -0.001, -10^(-7), 10^(-6), 0.01, 1}, PrecisionGoal -> 3]];
    On[NIntegrate::slwcon]; expr]

AAsp[VV1ex, term3][npole_, qmax_] := AAsp[IIA, term5b][npole, qmax]
BBsp[VV1ex, term3][npole_, qmax_] := BBsp[IIA, term5b][npole, qmax]
(*--#] *)

(* Total*sum *)

USConst[Enrgy_, opts:OptionsPattern[]] := With[
   {
   M = OptionValue[QuarkMass],
   alphas = OptionValue[alphaS]
   },
   N[(cF/(6*Pi^2))*I*GreenF[Enrgy/(M*alphas^2)] \
      /. tt[a_, b_] -> 1  \
      /. \[CapitalGamma]t -> \[CapitalGamma] \
      /. muP -> scalemu /. muP\[CapitalGamma] -> scalemu \
      /. muUS -> scalemu /. muUS\[CapitalGamma] -> scalemu \
      /. "Im[Ghat(0,e)]" -> 0 /. "\[CapitalGamma]t" -> 0]  \
      /. L[(0.8691964170141564*m*as^2)/scalemu]-> Log[0.8691964170141564] \
      /. L[loga_] -> 0
];

End[];
EndPackage[];
